$title  Aggregation of IO Table
$ontext

52x9n̘A֕\𓝍vOD


$offtext

$if not setglobal new_data $setglobal new_data dataio_23x8

*	----------------------------------------------------------------------
*	Set definitions:
display "com: Set definitions:";

* The aggregated SAM consists of the following elements:

set sam_i      original row of SAM data
     /s01*s55, v01*v07, output/;

set sam_j      original column of SAM data
     /s01*s55, d01*d19, output/;

set sam_r      region f SAM data
     /r0*r9/;

alias (sam_r,sam_s);
display sam_i, sam_j, sam_r;

set
    row_(sam_i)		Row (endogenous sector)
    / s01*s52 /
    col_(sam_j)		Column (endogenous sector)
    / s01*s52 /
    fd(sam_j)		Final demand
    / d01*d07,d10,d11,d15*d17 /
    va(sam_i)
    / v01*v06 /
    r_(sam_r)
    / r0*r8 /
    r_r(sam_r,sam_s)
;
r_r(sam_r,sam_r) = yes;
display row_, col_, fd, r_, r_r;
alias (s_,r_);

parameter
  data52(*,*,*,*)   "Reigonal IO data (col, row, r, s)";

$gdxin regionio52.gdx

$load data52

$gdxin

display "Original data", data52;

*	----------------------------------------------------------------------
*	Check original data (billion yen):
display "com: Check original data (billion yen):";

display "com: VA and FD consistency:";

parameter
    scale_factor
    chk_fd
    chk_va
    chk_fd_va;
scale_factor = 1000;

chk_fd(row_,s_,r_) =
    sum(fd, data52(fd,row_,s_,r_)) / scale_factor;
chk_fd("sum",s_,r_) =
    sum(row_, chk_fd(row_,s_,r_));
chk_fd(row_,"sum",r_) =
    sum(s_, chk_fd(row_,s_,r_));
chk_fd("sum","sum",r_) =
    sum(s_, sum(row_, chk_fd(row_,s_,r_)));
* option chk_fd:0;
display chk_fd;

chk_va(col_,s_,r_)
    = sum(va, data52(col_,va,s_,r_)) / scale_factor;
chk_va("sum","sum",r_)
    = sum(col_, sum(s_, chk_va(col_,s_,r_)));
* option chk_va:0;
display chk_va;

chk_fd_va(r_,"fd") = chk_fd("sum","sum",r_);
chk_fd_va("Sum","fd") = sum(r_, chk_fd_va(r_,"fd"));
chk_fd_va(r_,"va") = chk_va("sum","sum",r_);
chk_fd_va("Sum","va") = sum(r_, chk_fd_va(r_,"va"));
* option chk_fd_va:0;
display chk_fd_va;

display "com: VA data:";

parameter
    chk_va_ce		Compensation for employees
    chk_va_os		Operating surplus
    chk_va_depr		Depreciation allowance
    chk_va_indtax	Indirect tax
    chk_va_sub		Subsidies
;
chk_va_ce(col_,r_,s_)
    = (1/scale_factor) * data52(col_,"v02",r_,s_);
chk_va_os(col_,r_,s_)
    = (1/scale_factor) * data52(col_,"v03",r_,s_);
chk_va_depr(col_,r_,s_)
    = (1/scale_factor) * data52(col_,"v04",r_,s_);
chk_va_indtax(col_,r_,s_)
    = (1/scale_factor) * data52(col_,"v05",r_,s_);
chk_va_sub(col_,r_,s_)
    = (1/scale_factor) * data52(col_,"v06",r_,s_);
display chk_va_ce, chk_va_os, chk_va_depr, chk_va_indtax, chk_va_sub;

display "com: FD data:";

parameter
    chk_fd_pcon		Private consumption
    chk_fd_gcon		Government consumption
    chk_fd_ginv		Public fixed investment
    chk_fd_pinv		Private fixed investment
    chk_fd_imp		Import
    chk_fd_exp		Export
    chk_fd_imp_exp
    chk_fd_tariff_rate	"Tariff rate (%)"
    chk_fd_imptax_rate	"Tax rate on imported goods (%)"
;

chk_fd_pcon(row_,r_,s_)
    = (1/scale_factor) * data52("d02",row_,r_,s_);
chk_fd_gcon(row_,r_,s_)
    = (1/scale_factor) * data52("d03",row_,r_,s_);
chk_fd_pinv(row_,r_,s_)
    = (1/scale_factor) * data52("d05",row_,r_,s_);
chk_fd_ginv(row_,r_,s_)
    = (1/scale_factor) * data52("d04",row_,r_,s_);
chk_fd_imp(row_,r_,s_)
    = - (1/scale_factor) * data52("d15",row_,r_,s_);
chk_fd_exp(row_,r_,s_)
    = - (1/scale_factor) * (data52("d10",row_,r_,s_) + data52("d11",row_,r_,s_))
display chk_fd_pcon, chk_fd_gcon, chk_fd_ginv, chk_fd_pinv, chk_fd_imp, chk_fd_exp;

chk_fd_imp_exp(row_,r_,s_)$((not r_r(r_,s_)) and chk_fd_imp(row_,r_,s_))
    = chk_fd_imp(row_,r_,s_);
chk_fd_imp_exp(row_,r_,s_)$((not r_r(r_,s_)) and chk_fd_exp(row_,r_,s_))
    = chk_fd_exp(row_,r_,s_);
display chk_fd_imp_exp;

chk_fd_tariff_rate(row_,r_)$data52("d15",row_,r_,r_)
    = 100 * data52("d16",row_,r_,r_) / data52("d15",row_,r_,r_)
display chk_fd_tariff_rate;

chk_fd_imptax_rate(row_,r_)$data52("d15",row_,r_,r_)
    = 100 * data52("d17",row_,r_,r_) / data52("d15",row_,r_,r_)
display chk_fd_imptax_rate;

display "com: Intermediate data:";

parameter
    chk_neg_input	Negative intermediate input
;
chk_neg_input(col_,row_,r_,s_)$(data52(col_,row_,r_,s_) < 0)
    = data52(col_,row_,r_,s_) / scale_factor;
display chk_neg_input;

*	----------------------------------------------------------------------
*	Aggregation:
display "com: Aggregation:";

$include %new_data%.map

alias (agg_i,agg_j);
alias (agg_r,agg_s);
display agg_i, agg_r;

set mapagg_j(*,*)
    mapagg_s(*,*);

mapagg_j(agg_i,sam_i) = mapagg_i(agg_i,sam_i);
mapagg_s(agg_r,sam_r) = mapagg_r(agg_r,sam_r);
display mapagg_i, mapagg_r;

set
    s_va	Value added
    / lab      Labor
      cap      Capital
      taxi     Output tax
      sub      Subsidy
      output   Output /
    s_fd	Final demand
    / cp       Houshold consumption
      cg       Government consumption
      ig       Government capital formation
      inv      Private capital formation
      iij      Private inventory investment
      export   Exports
      import   Imports
      tariff   Tariff
      imptax   Commodity tax on imported goods
      output   Output /
;
set
    map_fd(s_fd,sam_j) /
      cp.(d01*d02)
      cg.d03
      ig.d04
      inv.d05
      iij.(d06,d07)
      export.d12
      import.d15
      tariff.d16
      imptax.d17
      output.output /
    map_va(s_va,sam_i) /
      lab.(v01,v02)
      cap.(v03,v04)
      taxi.v05
      sub.v06
      output.output /
;
display map_fd, map_va;

parameter
  dataagg(*,*,*,*)  "aggregated SAM (bil yen)";

dataagg(agg_i, agg_j, agg_r, agg_s)
      = sum((sam_i,sam_j,sam_r,sam_s)$
	  (mapagg_i(agg_i,sam_i)*mapagg_j(agg_j,sam_j)
	      *mapagg_r(agg_r,sam_r)*mapagg_s(agg_s,sam_s)),
	  data52(sam_j,sam_i,sam_r,sam_s))/1000;

dataagg(s_va, agg_j, agg_r, agg_s)
      = sum((sam_i,sam_j,sam_r,sam_s)$
	  (map_va(s_va,sam_i)*mapagg_j(agg_j,sam_j)
	      *mapagg_r(agg_r,sam_r)*mapagg_s(agg_s,sam_s)),
	  data52(sam_j,sam_i,sam_r,sam_s))/1000;

dataagg(agg_i, s_fd, agg_r, agg_s)
      = sum((sam_i,sam_j,sam_r,sam_s)$
	  (mapagg_i(agg_i,sam_i)*map_fd(s_fd,sam_j)
	      *mapagg_r(agg_r,sam_r)*mapagg_s(agg_s,sam_s)),
	  data52(sam_j,sam_i,sam_r,sam_s))/1000;

display dataagg;

dataagg("taxi", agg_j, agg_r, agg_s)
   =  dataagg("taxi", agg_j, agg_r, agg_s)
   +  dataagg("sub", agg_j, agg_r, agg_s);
dataagg("sub", agg_j, agg_r, agg_s) = 0;

display dataagg;

alias (agg_i,i), (agg_i,j);
alias (agg_r,r), (agg_r,s);

Parameters
  y0(j,r)         Output,
  ijs0(i,j,s,r)   Intermediate inputs,
  labs0(j,s,r)    Factor inputs,
  caps0(j,s,r)    Factor inputs,
  tys0(j,s,r)     Tax on output,
  cps0(i,s,r)     Private consumption,
  cgs0(i,s,r)     Government consumption,
  igs0(i,s,r)     Government capital formation,
  invs0(i,s,r)    Private capital formation,
  iijs0(i,s,r)    Inventory investment
  ex0(i,r)        Exports,
  im0(i,r)        Imports,
  tm0(i,r)        Tariff
  tmm0(i,r)       Tax on imported goods;

ijs0(i,j,s,r) = DataAGG(i,j,s,r);
labs0(j,s,r)  = DataAGG("lab",j,s,r);
caps0(j,s,r)  = DataAGG("cap",j,s,r);
tys0(j,s,r)   = DataAGG("taxi",j,s,r);
cps0(i,s,r)   = DataAGG(i,"cp",s,r);
cgs0(i,s,r)   = DataAGG(i,"cg",s,r);
igs0(i,s,r)   = DataAGG(i,"ig",s,r);
invs0(i,s,r)  = DataAGG(i,"inv",s,r);
iijs0(i,s,r)  = DataAGG(i,"iij",s,r);
ex0(i,r)      = DataAGG(i,"export",r,r);
im0(i,r)      = DataAGG(i,"import",r,r);
tm0(i,r)      = DataAGG(i,"tariff",r,r);
tmm0(i,r)     = DataAGG(i,"imptax",r,r);

*	inventory investment -> investment:
invs0(i,s,r) = invs0(i,s,r) + iijs0(i,s,r);
iijs0(i,s,r) = 0;

$ontext
*	----------------------------------------------------------------------
*	Data adjustment:
display "com: Data adjustment:";

display "Brefore adjustment", invs0, cgs0, igs0, cps0;

parameter
    chk_invs0	Check negative elements
    chk_cgs0	Check negative elements
    chk_igs0	Check negative elements
    chk_cps0	Check negative elements
    chk_ijs0	Check negative elements
;

chk_invs0(i,s,r)$(invs0(i,s,r) < 0) = invs0(i,s,r);
chk_cgs0(i,s,r)$(cgs0(i,s,r) < 0) = cgs0(i,s,r);
chk_igs0(i,s,r)$(igs0(i,s,r) < 0) = igs0(i,s,r);
chk_cps0(i,s,r)$(cps0(i,s,r) < 0) = cps0(i,s,r);
chk_ijs0(i,j,s,r)$(ijs0(i,j,s,r) < 0) = ijs0(i,j,s,r);
display chk_invs0, chk_cgs0, chk_igs0, chk_cps0, chk_ijs0;

cps0(i,s,r)$(invs0(i,s,r) < 0)   = cps0(i,s,r)+invs0(i,s,r);
invs0(i,s,r)$(invs0(i,s,r) < 0)  = 0;

cps0(i,s,r)$(cgs0(i,s,r) < 0)    = cps0(i,s,r)+cgs0(i,s,r);
cgs0(i,s,r)$(cgs0(i,s,r) < 0)    = 0;

cps0(i,s,r)$(igs0(i,s,r) < 0)    = cps0(i,s,r)+igs0(i,s,r);
igs0(i,s,r)$(igs0(i,s,r) < 0)    = 0;

display "After adjustment", invs0, cgs0, igs0, cps0;

* adjust for negtive input

* ijs0("chem","fuel","kyu","kyu") < 0 ƂȂĂ̂ŒD

cps0("chem","kyu","kyu")=cps0("chem","kyu","kyu")-ijs0("chem","fuel","kyu","kyu");
cps0("fuel","kyu","kyu")=cps0("fuel","kyu","kyu")+ijs0("chem","fuel","kyu","kyu");
ijs0("chem","fuel","kyu","kyu")=0;

DataAGG(i,"cp",s,r)  = cps0(i,s,r);
DataAGG(i,"cg",s,r)  = cgs0(i,s,r);
DataAGG(i,"ig",s,r)  = igs0(i,s,r);
DataAGG(i,"inv",s,r) = invs0(i,s,r);
DataAGG(i,"iij",s,r) = iijs0(i,s,r);
$offtext

*	Export new data set:
Execute_Unload '%new_data%.gdx',i,r,ijs0,labs0,caps0,tys0,cps0,cgs0,igs0,invs0,ex0,im0,tm0,tmm0;


$exit

Parameter Data(*,*,*,*);

* Data(agg_i,agg_r,agg_j,agg_s)=DataAGG(agg_i, agg_j, agg_r, agg_s);

*Execute_Unload 'DataAGG.gdx',Data;
*execute 'gdxxrw.exe DataAGG.gdx  par=Data  rng=io!a1 Rdim=2 Cdim=2';
*execute 'del DataAGG.gdx';

display "com: Display data";

display ijs0, labs0, caps0, tys0, cps0, cgs0, igs0, invs0, iijs0, ex0, im0,
	tm0,tmm0;

