$title	Multiregional CGE Model for Japanese Economy
display "com: Multiregional CGE Model for Japanese Economy";
$ontext
Time-stamp: 	<2008-04-23 00:04:06 Shiro Takeda>

z̒PʁF10~

$offtext
*	End-of-line comment symbol:
$eolcom #

*	Experiment name:
$if not setglobal exp_name $setglobal exp_name default_exp

*	Name of data gdx file:
$if not setglobal data_name $setglobal data_name dataio_23x8

*	Name of set definition file:
$if not setglobal set_file $setglobal set_file %data_name%.set

*	Name of tax data file:
$if not setglobal tax_name $setglobal tax_name .\tax_default.gms

*	Name of elasticity parameter file:
$if not setglobal elas_name $setglobal elas_name .\elas_default.par

*	Non-zero means fixed investment model:
$if not setglobal fix_inv $setglobal fix_inv 0

*	Solve by MCP:
$if not setglobal solve_mcp $setglobal solve_mcp 1

*	Solve by MPSGE:
$if not setglobal solve_mpsge $setglobal solve_mpsge 0

*	Non-zero -> ajust tariff data:
$if not setglobal adj_tariff $setglobal adj_tariff 1

*	Adjustment of tax data:
$if not setglobal adj_tariff_cons $setglobal adj_tariff_cons 1

*	Zero -> constant, and non-zero -> variable TOT:
$if not setglobal fl_tot $setglobal fl_tot 1

*	File of TOT data:
$if not setglobal tot_file $setglobal tot_file .\tot_default.gms

*	Non-zero -> services trade liberalization:
$if not setglobal fl_service $setglobal fl_service 0

*
$if not setglobal service_file $setglobal service_file .\service_trade_lib.gms

*	Name of tax data file:
$if not setglobal tax_name $setglobal tax_name .\tax_default.gms

*	Benchmark replication only:
$if not setglobal br_only $setglobal br_only 0

*	Cleanup calculation only:
$if not setglobal cc_only $setglobal cc_only 0

*	Scale shock experiment:
$if not setglobal scale_shock $setglobal scale_shock 0

*	Alternative BOP adjustment:
$if not setglobal fl_bop $setglobal fl_bop 0

*	Government expenditure
$if not setglobal fl_gov $setglobal fl_gov 1

*	
$if not setglobal fl_redis $setglobal fl_redis 0

$if not setglobal fl_land $setglobal fl_land 1

*	Name of files to which results are exported:
$setglobal gdx_results .\results\%exp_name%_results.gdx
$setglobal excel_results .\results\%exp_name%_results.xls
$setglobal gdx_data .\results\%data_name%_benchmark_data.gdx
$setglobal excel_data .\results\%data_name%_benchmark_data.xls

*	Values of variables:
display "exp_name = %exp_name%";
display "data_name = %data_name%";
display "set_file = %set_file%";
display "tax_name = %tax_name%";
display "elas_name = %elas_name%";
display "fix_inv = %fix_inv%";
display "solve_mcp = %solve_mcp%";
display "solve_mpsge = %solve_mpsge%";
display "adj_tariff = %adj_tariff%";
display "adj_tariff_cons = %adj_tariff_cons%";
display "fl_tot = %fl_tot%";
display "tot_file = %tot_file%";
display "fl_service = %fl_service%";
display "service_file = %service_file%";
display "tax_name = %tax_name%";
display "br_only = %br_only%";
display "cc_only = %cc_only%";
display "scale_shock = %scale_shock%";
display "fl_bop = %fl_bop%";
display "fl_gov = %fl_gov%";
display "excel_data = %excel_data%";
display "gdx_results = %gdx_results%";
display "excel_results = %excel_results%";
display "gdx_data = %gdx_data%";
display "excel_data = %excel_data%";
display "fl_redis = %fl_redis%";

parameter
    fix_inv	/ %fix_inv% /
    fl_bop	/ %fl_bop% /
    fl_gov	/ %fl_gov% /
    fl_redis	/ %fl_redis% /
    fl_land	/ %fl_land% /
;
display fix_inv, fl_bop, fl_gov, fl_redis, fl_land;

*	File name for displaying title in DOS window.
file titlemaker /'titlemaker.cmd'/;

putclose titlemaker '@title Solving scenario = %exp_name%', ', Ctrl-S to pause'/;
execute 'titlemaker.cmd';

*	----------------------------------------------------------------------
*	Read data:
display "com: Read data";

set i(*)  Sectors
    r(*)  Regions
;
alias (i,j), (r,s);
alias (i,ii), (r,rr);

Parameters
    y0(j,r)	    Output,
    yd0(j,r)	    Output for domestic use,
    ya0(j,r)	    Armington aggregates,
    ijs0(i,j,s,r)   Intermediate inputs,
    labs0(j,s,r)    Factor inputs,
    lab0(r)	    Factor inputs,
    caps0(j,s,r)    Factor inputs,
    cap0(r)	    Factor inputs,
    tys0(j,s,r)	    Indirect tax on output,
    ty0(j,r)	    Indirect tax on output,

    cs0(i,r,s)	    Consumption
    c0(*)	    Consumption

    cps0(i,s,r)	    Private consumption,
    cp0(*)	    Private consumption,

    cgs0(i,s,r)	    Government consumption,
    cg0(*)	    Government consumption,
    igs0(i,s,r)	    Government capital formation,
    ig0(*)	    Government capital formation,

    gexp0(*)	    Government expenditure
    gexps0(i,s,r)   Government expenditure

    invs0(i,s,r)    Capital formation,
    inv0(*)	    Capital formation,

    ex0(i,r)	    Exports,
    im0(i,r)	    Imports,
    tm0(i,r)	    Tariff
    tmm0(i,r)	    Tax on imported goods
    imw0	    Value of import (including tariffs + import tax)
    imw_0	    Value of import (including tariffs)
;

$ontext
GDXt@Cf[^ǂݍށD
$offtext
*	Import data:
$gdxin %data_name%

* $load i,r,ijs0,labs0,caps0,tys0,cps0,cgs0,igs0,invs0,ex0,im0,tm0,tmm0	# This does not work in old GAMS system.
$load i r ijs0 labs0 caps0 tys0 cps0 cgs0 igs0 invs0 ex0 im0 tm0 tmm0

display "com: Imported data";
display i, r, ijs0, labs0, caps0, tys0, cps0, cgs0, igs0, invs0, ex0, im0,
	tm0,tmm0;

*	Include set definition file:
$if exist %set_file% $include %set_file%

if(fl_gov,
    cs0(i,s,r) = cps0(i,s,r);
    gexps0(i,s,r) = cgs0(i,s,r) + igs0(i,s,r);
else
    cs0(i,s,r) = cps0(i,s,r) + cgs0(i,s,r);
    invs0(i,s,r) = invs0(i,s,r) + igs0(i,s,r);
    gexps0(i,s,r) = 0;
    cps0(i,s,r) = 0;
    cgs0(i,s,r) = 0;
    igs0(i,s,r) = 0;
);
display cgs0, igs0, cs0, invs0, gexps0;

*display i,r,ijs0,labs0,caps0,tys0,cps0,cgs0,igs,invs0,ex0,im0,tm0;

set	r_r(r,s)
	r_s(r,s)
;
r_r(r,s) = no;
r_r(r,r) = yes;
r_s(r,s) = yes;
r_s(r,r) = no;
display r_r, r_s;

*	----------------------------------------------------------------------
*	Adjustment to capital and land:
parameter
    sh_land	Share of land in Agriculture inputs
    caps0_old(j,s,r)

    lnds0(j,s,r)
    lnd0(i,r)
;
* sh_land = land / capital:
sh_land(j) = 0;
if(fl_land,
    sh_land("agr") = 7552.7 / (21986.3 + 7552.7);
);
display sh_land;

caps0_old(j,s,r) = caps0(j,s,r);
lnds0(j,r,r) = sh_land(j) * caps0_old(j,r,r);
caps0(j,r,r) = caps0(j,r,r) - lnds0(j,r,r);
display lnds0, caps0;

lnd0(i,r) = sum(s, lnds0(i,r,s));
display lnd0;

*	Import parameters:
$include %tax_name%

*	Import elasticity parameters:
$include %elas_name%

$if %adj_tariff%==0 $goto end_adj_tariff
*	----------------------------------------------------------------------
*	Adjust tariff rates:
display "com: Adjust tariff rates:";
$ontext
֐ŗ̏CȂ

GTAPf[^ɍĊ֐ŗ㏸D
$offtext
display "Import and tariff data before adjustment", tm0, im0;

parameter
    org_rate		Original average tariff rate
    adjusted_rate	average rate of adjusted tariif
    imw_0_		Value of import (including tariffs)

    sc_m		Scale factor for adjusting import
    sc_t		Scale factor for adjusting tariff

    org_cs		Original consumption data
    org_ex		Original export data
    chk_ratio_ex
    chk_ratio_cs
;
display target_rate;

org_rate(i)$(sum(r, im0(i,r))) = sum(r, tm0(i,r)) / sum(r, im0(i,r));
display org_rate;

loop(i$target_rate(i),

    imw_0_(i,r,"org") = - (im0(i,r) + tm0(i,r));
    imw_0_(i,"sum","org") = sum(r, imw_0_(i,r,"org"));

    sc_m(i) = imw_0_(i,"sum","org") / ((1 + target_rate(i)) * sum(r, - im0(i,r)));
    sc_t(i) = target_rate(i) * sc_m(i) * sum(r, - im0(i,r)) / sum(r, - tm0(i,r));
*     display sc_m, sc_t;

    tm0(i,r) = sc_t(i) * tm0(i,r);
    im0(i,r) = sc_m(i) * im0(i,r);

    imw_0_(i,r,"adj") = - (im0(i,r) + tm0(i,r));
    imw_0_(i,r,"diff") = imw_0_(i,r,"adj") - imw_0_(i,r,"org");
    imw_0_(i,"sum","diff") = sum(r, imw_0_(i,r,"diff"));
*     display imw_0_;

    if(%adj_tariff_cons%,
*	adjustment by consumption
	display "Adjust consumption";
	org_cs(i,r,s) = cs0(i,r,s);
	cs0(i,r,r) = cs0(i,r,r) + imw_0_(i,r,"diff");
	chk_ratio_cs(i,r)
	    = 100 * (sum(s, cs0(i,s,r)) / sum(s, org_cs(i,s,r)) - 1);
	display cs0, chk_ratio_cs;
    else
*	adjustment by export
	display "Adjust export";
	org_ex(i,r) = ex0(i,r);
	ex0(i,r) = ex0(i,r) + imw_0_(i,r,"diff");
	chk_ratio_ex(i,r) = 100 * (org_ex(i,r) / ex0(i,r) - 1);
	display ex0, chk_ratio_ex;
    );
);

display "Import and tariff data after adjustment", tm0, im0;

adjusted_rate(i)$(sum(r, im0(i,r))) = sum(r, tm0(i,r)) / sum(r, im0(i,r));
display adjusted_rate;

$label end_adj_tariff

im0(i,r) = - im0(i,r);
tm0(i,r) = - tm0(i,r);
tmm0(i,r) = - tmm0(i,r);
imw_0(i,r) = im0(i,r) + tm0(i,r);
imw0(i,r) = im0(i,r) + tm0(i,r) + tmm0(i,r);
imw_0(i,"sum") = sum(r, imw_0(i,r));
imw_0("sum",r) = sum(i, imw_0(i,r));
imw_0("sum","sum") = sum((i,r), imw_0(i,r));
imw0(i,"sum") = sum(r, imw0(i,r));
imw0("sum",r) = sum(i, imw0(i,r));
imw0("sum","sum") = sum((i,r), imw0(i,r));
display imw_0, imw0;

parameter
    tax_rate	Tariff and import tax rates
    chk_tax_rate
;
tax_rate(i,r,"tariff")$im0(i,r) = tm0(i,r) / im0(i,r);
tax_rate(i,r,"imptax")$im0(i,r) = tmm0(i,r) / im0(i,r);
display tax_rate;

chk_tax_rate(i,r,"sum") = tax_rate(i,r,"tariff") + tax_rate(i,r,"imptax");
chk_tax_rate(i,r,"sum_")$im0(i,r) = (tm0(i,r) + tmm0(i,r)) / im0(i,r);
display chk_tax_rate;

*	----------------------------------------------------------------------
*	Define parameters:
display "com: Define parameters:";

*	Value of output at market price:
y0(j,r) = sum((i,s), ijs0(i,j,s,r))
    + sum(s, labs0(j,s,r)) + sum(s, caps0(j,s,r))
    + sum(s, lnds0(j,s,r))
    + sum(s, tys0(j,s,r));

*	Domestic supply:
yd0(j,r) = y0(j,r) - ex0(j,r);

*	Armington supply = domestic supply + import supply:
ya0(j,r) = yd0(j,r) + im0(j,r) + tm0(j,r);

*	Consumption:
c0(r)	= sum((i,s), cs0(i,s,r));
c0("sum")   = sum(r, c0(r));

*	Capital formation:
inv0(r)	 = sum((i,s), invs0(i,s,r));
inv0("Sum") = sum(r, inv0(r));

*	Government expenditure:
gexp0(r) = sum((i,s), gexps0(i,s,r));
gexp0("sum") = sum(r, gexp0(r));

display y0, yd0, ya0, c0, gexp0, inv0;

*===========================================================
*   Tax
*===========================================================

parameter
    taxy0(j,r)	  Output tax rate,
    taxm0(j,r)	  "Tariff + import tax rate",
    v_tariff	  "Tariff + import tax revenue"
    v_inc_tax	  Income tax revenue
    v_tax_out	  Output tax

    py0(j,r)	  Output price tax excluded,
    pl0(r)	  Labor cost tax included,
    pk0(r)	  Capital cost tax included,
    pm0(j,r)	  Import price tax included
;
taxy0(j,r)$y0(j,r)  = sum(s, tys0(j,s,r))/y0(j,r);
py0(j,r)    = 1 - taxy0(j,r);

* option  taxl0:6, taxk0:6;
* display taxl0, taxk0;

labs0(j,s,r) = labs0(j,s,r)*(1-taxl0(s));
lab0(r)	     = sum((j,s), labs0(j,r,s));
taxl0(r)     = taxl0(r)/(1-taxl0(r));
pl0(r)	     = 1+taxl0(r);

caps0(j,s,r) = caps0(j,s,r)*(1-taxk0(s));
cap0(r)	     = sum((j,s),caps0(j,r,s));
taxk0(r)     = taxk0(r)/(1-taxk0(r));
pk0(r)	     = 1+taxk0(r);

taxm0(j,r)$im0(j,r) = (tm0(j,r) + tmm0(j,r)) / im0(j,r);
pm0(j,r) = 1 + taxm0(j,r);
display taxy0, taxm0;
display py0, pl0, pk0, pm0;
display taxl0, taxk0, labs0, labs0, caps0, cap0;

v_inc_tax(r,"lab") = taxl0(r) * lab0(r);
v_inc_tax(r,"cap") = taxk0(r) * cap0(r);
v_inc_tax("sum","lab") = sum(r, v_inc_tax(r,"lab"));
v_inc_tax("sum","cap") = sum(r, v_inc_tax(r,"cap"));
v_inc_tax(r,"sum") = v_inc_tax(r,"cap") + v_inc_tax(r,"lab");
v_inc_tax("sum","sum") = v_inc_tax("sum","cap") + v_inc_tax("sum","lab");
display v_inc_tax;

v_tariff(r,i) = (tm0(i,r) + tmm0(i,r));
v_tariff("sum",i) = sum(r, v_tariff(r,i));
v_tariff(r,"sum") = sum(i, v_tariff(r,i));
v_tariff("sum","sum") = sum((r,i), v_tariff(r,i));
display v_tariff;

v_tax_out(i,r) = taxy0(i,r) * y0(i,r);
v_tax_out("sum",r) = sum(i, v_tax_out(i,r));
v_tax_out("sum","sum") = sum((i,r), v_tax_out(i,r));
display v_tax_out;

*===========================================================
*   Saving
*===========================================================

Parameters
    hsave0(*)	  Household saving
    bop0(*)	  Balance of payment
    trn0(*)	  Transfer income to each region from central government
    hexp0(*)	  Household total expenditure
;
*	BOP = export - import:
bop0(r)	= sum(i, ex0(i,r) - im0(i,r));
bop0("sum") = sum(r, bop0(r));
if((not fl_bop), bop0(r) = 0);
display bop0;

*	Transfer to each region = consumption + investment + BOP surplus - factor income:
trn0(r) = c0(r) + inv0(r) + gexp0(r) + bop0(r) - (lab0(r) + cap0(r) + sum(i, lnd0(i,r)));
trn0("sum") = sum(r, trn0(r));
display trn0;

*	Total expenditure of household:
hexp0(r) = c0(r) + inv0(r);
display hexp0;

set rnum(r)  Numeraire region;
rnum(r) = yes$(c0(r)=smax(s, c0(s)));
display rnum;

*	----------------------------------------------------------------------
*	Parameters for policy analysis:
display "com: Parameters for policy analysis:";

parameter
    s_f		Scale parameter 	/ 1 /
    e_trade	Efficiency parameters
    e_tot	TOT parameter
;
e_trade(i,r) = 1;
e_tot(i,r) = 1;
display s_f, e_trade;

parameter
    t_labs0(j,r)	Total labor input of sector j in region r
    t_caps0(j,r)	Total capital input of sector j in region r
    t_lnds0(j,r)	Total land input of sector j in region r
;

t_labs0(j,r) = sum(s, pl0(s) * labs0(j,s,r));
t_caps0(j,r) = sum(s, pk0(s) * caps0(j,s,r));
t_lnds0(j,r) = sum(s, lnds0(j,s,r));
display t_labs0, t_caps0, t_lnds0;

*	----------------------------------------------------------------------
*	Parameters for Armington aggregation:
parameter
    a0(i,r)		Armington goods (by regions)
    ad0(i,r)		Aggregated domestic goods (by regions)

    sup_dom0		Domestic supply
    sup_imp0		Import supply
    sup_tot0		Total supply

    t_ijs0(i,j,r)
    t_cs0(i,r)
    t_invs0(i,r)
    t_gexps0(i,r)
;
sup_imp0(i,r) = imw0(i,r);
sup_dom0(i,s,r) = sum(j, ijs0(i,j,s,r)) + cs0(i,s,r) + invs0(i,s,r) + gexps0(i,s,r);
sup_dom0(i,r,r) = sum(j, ijs0(i,j,r,r)) + cs0(i,r,r) + invs0(i,r,r) + gexps0(i,r,r) - sup_imp0(i,r);
sup_dom0(i,r,s) = round(sup_dom0(i,r,s), 8);
sup_tot0(i,r) = sup_imp0(i,r) + sum(s, sup_dom0(i,s,r));
display sup_imp0, sup_dom0, sup_tot0;

loop((i,r,s),
    abort$(sup_imp0(i,r) < 0) "Inconsistent data!!!", sup_imp0;
    abort$(sup_dom0(i,s,r) < 0) "Inconsistent data!!!", sup_dom0;
);

a0(i,r) = sup_tot0(i,r);
ad0(i,r) = sum(s, sup_dom0(i,s,r));
display a0, ad0;

t_ijs0(i,j,r) = sum(s, ijs0(i,j,s,r));
t_cs0(i,r) = sum(s, cs0(i,s,r));
t_invs0(i,r) = sum(s, invs0(i,s,r));
t_gexps0(i,r) = sum(s, gexps0(i,s,r));
display t_ijs0, t_cs0, t_invs0, t_gexps0;

parameter
    pop		"Population (1000)" /
    hok		5683
    toh		9817
    kan		49780
    chb		13310
    kin		21685
    chg		7733
    sik		4154
    kyu		14764
    /;
pop("sum") = sum(r, pop(r));
display pop;

*	----------------------------------------------------------------------
*	Check benchmark data:
display "com: Check benchmark data:";

*	----------------------------------------------------------------------
*	RCA index:
$ontext
RCA index

rca_index(i,r)
= (nr̍i̗Ao / nȓAo) / (Sn̍i̗Ao / Sn̑Ao)

rca_index > 1 -> rDʂ

ł̗AóuΊOAo{Oւ̋vƒ`Ă邱ƂɒӁDrca_index 
̑̒nƔrĂ̔rDʁD̍Ƃ̔rDʂł͂ȂƂɒӁD

F hok ł fue  rca_index  25.51 ƔɍlChok {
̑̒nɑ΂ĔrDʂƂƂłāCCOɑ΂ĔrDʂ
Ƃł͂ȂDہC{ fue ̗Ao̓[ɋ߂CŜōlΓ{
fue ɔrDʂȂƂ͖炩łD

$offtext
parameter
    exp_ext		Export data
    exp_int		Export data
    exp_t		Total export
    rca_index		Revealed comparative advantage index (RCA)
    rca_index_exp	"Revealed comparative advantage index (RCA) > 1"

    rca_index_alt	Revealed comparative advantage index (RCA)
    rca_index_exp_alt	"Revealed comparative advantage index (RCA) > 1"
;

exp_ext(i,r) = ex0(i,r);
exp_int(i,r) =
    sum(j, sum(s$r_s(r,s), ijs0(i,j,r,s))) + sum(s$r_s(r,s), cs0(i,r,s)) + sum(s$r_s(r,s), invs0(i,r,s));
exp_int("sum",r) = sum(i, exp_int(i,r));
exp_int(i,"sum") = sum(r, exp_int(i,r));
exp_int("sum","sum") = sum((i,r), exp_int(i,r));
exp_t(i,r) = exp_ext(i,r) + exp_int(i,r);
exp_t("sum",r) = sum(i, exp_t(i,r));
exp_t(i,"sum") = sum(r, exp_t(i,r));
exp_t("sum","sum") = sum((i,r), exp_t(i,r));

rca_index(i,r)
    = (exp_t(i,r) / exp_t("sum",r))
    / (exp_t(i,"sum") / exp_t("sum","sum"));

rca_index_exp(i,r)$(rca_index(i,r) > 1)
    = rca_index(i,r);

option rca_index:2;
option rca_index_exp:2;
display rca_index;
display rca_index_exp;

rca_index_alt(i,r)$(exp_int("sum",r) and exp_int(i,"sum"))
    = (exp_int(i,r) / exp_int("sum",r))
    / (exp_int(i,"sum") / exp_int("sum","sum"));

rca_index_exp_alt(i,r)$(rca_index_alt(i,r) > 1)
    = rca_index_alt(i,r);

option rca_index_alt:2;
option rca_index_exp_alt:2;
display rca_index_alt;
display rca_index_exp_alt;

*	----------------------------------------------------------------------
*	Trade data:
$ontext
ΊOfՂ̃f[^D

$offtext
parameter
    trade_data		"Trade data (value)"
    trade_data_sh	"Trade data share (%)"
    tariff_rate		"Tariff rates (%)"
;
trade_data(i,"exp") = sum(r, ex0(i,r));
trade_data(i,"imp") = sum(r, im0(i,r));
trade_data(i,"net_exp") = trade_data(i,"exp") - trade_data(i,"imp");
trade_data("sum","exp") = sum(i, trade_data(i,"exp"));
trade_data("sum","imp") = sum(i, trade_data(i,"imp"));
trade_data("sum","net_exp") = sum(i, trade_data(i,"net_exp"));
option trade_data:1;
display trade_data;

trade_data_sh(i,"exp(%)") = 100 * trade_data(i,"exp") / trade_data("sum","exp");
trade_data_sh(i,"imp(%)") = 100 * trade_data(i,"imp") / trade_data("sum","imp");
trade_data_sh("sum","exp(%)") = sum(i, trade_data_sh(i,"exp(%)"));
trade_data_sh("sum","imp(%)") = sum(i, trade_data_sh(i,"imp(%)"));
option trade_data_sh:2;
display trade_data_sh;

tariff_rate(i,r)$im0(i,r) = 100 * tm0(i,r) / im0(i,r);
tariff_rate(i,"sum")$sum(r, im0(i,r)) = 100 * sum(r, tm0(i,r)) / sum(r, im0(i,r));
tariff_rate("sum",r)$sum(i, im0(i,r)) = 100 * sum(i, tm0(i,r)) / sum(i, im0(i,r));
display tariff_rate;

*	----------------------------------------------------------------------
*	Tax and transfer data:

set	tax_	/ cap, lab, tariff, oth /;
parameter
    tax_data
    tax_data_summary
    trans_data
;
tax_data("sum",r,"cap") = taxk0(r) * cap0(r);
tax_data("sum",r,"lab") = taxl0(r) * lab0(r);
tax_data(i,r,"out") = taxy0(i,r) * y0(i,r);
tax_data("sum",r,"out") = sum(i, tax_data(i,r,"out"));
tax_data(i,r,"tariff") = tax_rate(i,r,"tariff") * im0(i,r);
tax_data("sum",r,"tariff") = sum(i, tax_data(i,r,"tariff"));
tax_data(i,r,"imptax") = tax_rate(i,r,"imptax") * im0(i,r);
tax_data("sum",r,"imptax") = sum(i, tax_data(i,r,"imptax"));
tax_data("sum","sum",tax_) = sum(r, tax_data("sum",r,tax_));
tax_data("sum",r,"sum") = sum(tax_, tax_data("sum",r,tax_));
tax_data("sum","sum","sum") = sum((r,tax_), tax_data("sum",r,tax_));
display tax_data;

tax_data_summary(r,tax_) = tax_data("sum",r,tax_);
tax_data_summary(r,"oth") = tax_data("sum",r,"out") + tax_data("sum",r,"imp");
tax_data_summary("sum",tax_) = sum(r, tax_data_summary(r,tax_));
tax_data_summary(r,"sum") = sum(tax_, tax_data_summary(r,tax_));
tax_data_summary("sum","sum") = sum((r,tax_), tax_data_summary(r,tax_));
display tax_data_summary;

trans_data(r,"v") = c0(r) + inv0(r) + gexp0(r) - (lab0(r) + cap0(r) + sum(i, lnd0(i,r)));
trans_data("sum","v") = sum(r, trans_data(r,"v"));
trans_data(r,"%") = 100 * trans_data(r,"v") / trans_data("sum","v");
trans_data(r,"t/i") = 100 * trans_data(r,"v") / (lab0(r) + cap0(r) + sum(i, lnd0(i,r)) + trans_data(r,"v"));
display trans_data;

*	----------------------------------------------------------------------
*	Consumption:
display "com: Consumption:";
parameter
    sh_fd	Share in final demand
;
sh_fd(i,r) =
    100 * t_cs0(i,r) / sum(ii, t_cs0(ii,r));
display sh_fd;

*	----------------------------------------------------------------------
*	Summary:
display "com: Summary:";

parameter
    gdp
    gdp_pc
    gdp_va
    gdp_va_pc
    inc_pc
    va_by_sec		Value added by sector
    va_by_sec_sh	"Value added by sector (%)"
;
gdp(r,"GDP(v)") = c0(r) + inv0(r) + gexp0(r) + sum(i, ex0(i,r) - imw0(i,r))
    + sum((i,s), sup_dom0(i,r,s)) - sum((i,s), sup_dom0(i,s,r));
gdp("sum","GDP(v)") = sum(r, gdp(r,"GDP(v)"));
gdp_pc(r,"1000/pc") = 1000 * gdp(r,"GDP(v)") / pop(r);
gdp_pc("sum","1000/pc") = 1000 * gdp("sum","GDP(v)") / pop("sum");
display gdp, gdp_pc;

gdp_va(r,"GDP(v)")
    = sum(j, t_labs0(j,r) + t_caps0(j,r) + t_lnds0(j,r)
	+ taxy0(j,r) * (yd0(j,r) + ex0(j,r)));
gdp_va("sum","GDP(v)") = sum(r, gdp_va(r,"GDP(v)"));
gdp_va_pc(r,"mil/pc") = gdp_va(r,"GDP(v)") / pop(r);
gdp_va_pc("sum","mil/pc") = gdp_va("sum","GDP(v)") / pop("sum");
display gdp_va, gdp_va_pc;

va_by_sec(j,r)
    = t_labs0(j,r) + t_caps0(j,r) + t_lnds0(j,r) + taxy0(j,r) * (yd0(j,r) + ex0(j,r));
va_by_sec("sum",r) = sum(j, va_by_sec(j,r));
va_by_sec_sh(j,r)
    = 100 * va_by_sec(j,r) / va_by_sec("sum",r);
va_by_sec_sh("sum",r) = sum(j, va_by_sec_sh(j,r));
option va_by_sec:2, va_by_sec_sh:2;
display va_by_sec, va_by_sec_sh;

inc_pc(r,"inc/pc") = hexp0(r) / pop(r);
display inc_pc;

parameter
    inc_gov;
inc_gov(r) = 100 * gexp0(r) / hexp0(r);
display inc_gov;


*	----------------------------------------------------------------------
*
parameter
    sh_own_sup_prod	Share of supply to own region in production
    sh_own_sup_con	Share of own supply in consumption
;
sh_own_sup_prod(i,r)$y0(i,r)
    = 100 * ((y0(i,r) - exp_t(i,r)) / y0(i,r));
display sh_own_sup_prod;

sh_own_sup_con(i,r)$sum(s, sup_dom0(i,s,r))
    = 100 * sup_dom0(i,r,r) / (sup_dom0(i,r,r) + sum(s, sup_dom0(i,s,r)));
display sh_own_sup_con;

parameter
        summary
;
summary(r,"GDP(v)") = gdp(r,"GDP(v)");
summary("sum","GDP(v)") = sum(r, summary(r,"GDP(v)"));
summary(r,"GDP(%)")
    = 100 * summary(r,"GDP(v)") / summary("sum","GDP(v)");
summary(r,tax_)
    = tax_data_summary(r,tax_);

summary(r,tax_) = tax_data_summary(r,tax_);
summary("sum",tax_) = tax_data_summary("sum",tax_);
summary(r,"sum") = tax_data_summary(r,"sum");
summary("sum","sum") = tax_data_summary("sum","sum");

summary(r,"trans(v)") = trans_data(r,"v");
summary("sum","trans(v)") = trans_data("sum","v");
summary(r,"trans(%)") = trans_data(r,"%");
summary(r,"t/i") = trans_data(r,"t/i");

summary(r,"GDP/pc") = gdp_pc(r,"1000/pc");
summary("sum","GDP/pc") = gdp_pc("sum","1000/pc");
summary(r,"pop") = pop(r);
summary("sum","pop") = pop("sum");

display summary;

Execute_Unload '%gdx_data%',
    gdp_pc, rca_index, rca_index_exp, rca_index_alt, rca_index_exp_alt, trade_data, tariff_rate,
    trade_data_sh, tax_data, tax_data_summary, trans_data, va_by_sec, va_by_sec_sh, summary;

execute 'gdxxrw %gdx_data% o=%excel_data% par=va_by_sec_sh rng=va_by_sec_sh!A1 rdim=1 cdim=1'
execute 'gdxxrw %gdx_data% o=%excel_data% par=va_by_sec rng=va_by_sec!A1 rdim=1 cdim=1'
execute 'gdxxrw %gdx_data% o=%excel_data% par=gdp_pc rng=gdp_pc!A1 rdim=1 cdim=1'
execute 'gdxxrw %gdx_data% o=%excel_data% par=rca_index rng=rca_index!A1 rdim=1 cdim=1'
execute 'gdxxrw %gdx_data% o=%excel_data% par=rca_index_exp rng=rca_index_exp!A1 rdim=1 cdim=1'
execute 'gdxxrw %gdx_data% o=%excel_data% par=rca_index_alt rng=rca_index_alt!A1 rdim=1 cdim=1'
execute 'gdxxrw %gdx_data% o=%excel_data% par=rca_index_exp_alt rng=rca_index_exp_alt!A1 rdim=1 cdim=1'
execute 'gdxxrw %gdx_data% o=%excel_data% par=trade_data rng=trade_data!A1 rdim=1 cdim=1'
execute 'gdxxrw %gdx_data% o=%excel_data% par=tariff_rate rng=tariff_rate!A1 rdim=1 cdim=1'
execute 'gdxxrw %gdx_data% o=%excel_data% par=tax_data rng=tax_data!A1 rdim=1 cdim=1'
execute 'gdxxrw %gdx_data% o=%excel_data% par=tax_data_summary rng=tax_data_summary!A1 rdim=1 cdim=1'
execute 'gdxxrw %gdx_data% o=%excel_data% par=trans_data rng=trans_data!A1 rdim=1 cdim=1'
execute 'gdxxrw %gdx_data% o=%excel_data% par=summary rng=summary!A1 rdim=1 cdim=1'

$label end
* --------------------
* local variables:
* mode: gams
* fill-column: 80
* end:
