$title	Multiregional CGE Model for Japanese Economy
display "com: Multiregional CGE Model for Japanese Economy";
$ontext
Time-stamp: 	<2008-06-03 18:29:46 Shiro Takeda>

cjYE (2008)
wfՎŘʂɂnԊiFnԎYƘA֕\𗘗ppʋύt́x

ɂV~[ṼvOB

z̒PʁF10~

$offtext
*	End-of-line comment symbol:
$eolcom #

*	-----------------------------------------------------------------
*	Definition of global variables:

*	Experiment name:
$if not setglobal exp_name $setglobal exp_name default_exp

*	Name of data gdx file:
$if not setglobal data_name $setglobal data_name dataio_23x8

*	Name of set definition file:
$if not setglobal set_file $setglobal set_file %data_name%.set

*	Name of population data file:
$if not setglobal pop_file $setglobal pop_file %data_name%_pop.gms

*	Name of tax data file:
$if not setglobal tax_name $setglobal tax_name .\tax_default.gms

*	Name of elasticity parameter file:
$if not setglobal elas_name $setglobal elas_name .\elas_default.par

*	Non-zero means fixed investment model:
$if not setglobal fix_inv $setglobal fix_inv 0

*	Solve by MCP:
$if not setglobal solve_mcp $setglobal solve_mcp 1

*	Solve by MPSGE:
$if not setglobal solve_mpsge $setglobal solve_mpsge 0

*	Non-zero -> ajust tariff data:
$if not setglobal adj_tariff $setglobal adj_tariff 1

*	Adjustment of tax data:
$if not setglobal adj_tariff_cons $setglobal adj_tariff_cons 1

*	Zero -> constant, and non-zero -> variable TOT:
$if not setglobal fl_tot $setglobal fl_tot 1

*	File of TOT data:
$if not setglobal tot_file $setglobal tot_file .\tot_default.gms

*	Non-zero -> services trade liberalization:
$if not setglobal fl_service $setglobal fl_service 0

*	Setting for service trade liberalization:
$if not setglobal service_file $setglobal service_file .\service_trade_lib.gms

*	Benchmark replication only:
$if not setglobal br_only $setglobal br_only 0

*	Cleanup calculation only:
$if not setglobal cc_only $setglobal cc_only 0

*	Scale shock experiment:
$if not setglobal scale_shock $setglobal scale_shock 0

*	Alternative BOP adjustment:
$if not setglobal fl_bop $setglobal fl_bop 0

*	Government expenditure (if zero, gov. expenditure is aggregated to
*	private consumption):
$if not setglobal fl_gov $setglobal fl_gov 1

*	If non-zero, transfer is determined so that all regions receive the same
*	gains from liberalization:
$if not setglobal fl_redis $setglobal fl_redis 0

*	If zero, land is aggregated into capital:
$if not setglobal fl_land $setglobal fl_land 1

*	Name of files to which results are exported:
$setglobal gdx_results .\results\%exp_name%_results.gdx
$setglobal excel_results .\results\%exp_name%_results.xls
$setglobal gdx_data .\results\%data_name%_benchmark_data.gdx
$setglobal excel_data .\results\%data_name%_benchmark_data.xls

*	Values of variables:
display "exp_name = %exp_name%";
display "data_name = %data_name%";
display "set_file = %set_file%";
display "tax_name = %tax_name%";
display "elas_name = %elas_name%";
display "fix_inv = %fix_inv%";
display "solve_mcp = %solve_mcp%";
display "solve_mpsge = %solve_mpsge%";
display "adj_tariff = %adj_tariff%";
display "adj_tariff_cons = %adj_tariff_cons%";
display "fl_tot = %fl_tot%";
display "tot_file = %tot_file%";
display "fl_service = %fl_service%";
display "service_file = %service_file%";
display "br_only = %br_only%";
display "cc_only = %cc_only%";
display "scale_shock = %scale_shock%";
display "fl_bop = %fl_bop%";
display "fl_gov = %fl_gov%";
display "fl_redis = %fl_redis%";
display "fl_land = %fl_land%";
display "gdx_results = %gdx_results%";
display "excel_results = %excel_results%";
display "gdx_data = %gdx_data%";
display "excel_data = %excel_data%";

parameter
    fix_inv	/ %fix_inv% /
    fl_bop	/ %fl_bop% /
    fl_gov	/ %fl_gov% /
    fl_redis	/ %fl_redis% /
    fl_land	/ %fl_land% /
;
display fix_inv, fl_bop, fl_gov, fl_redis, fl_land;

*	File name for displaying title in DOS window.
file titlemaker /'titlemaker.cmd'/;

putclose titlemaker '@title Solving scenario = %exp_name%' /;
execute 'titlemaker.cmd';

*	----------------------------------------------------------------------
*	Read data:
display "com: Read data";

set	i(*)	Index of sectors
	r(*)	Index of regions
;
alias (i,j), (r,s);
alias (i,ii), (r,rr);

parameters
    y0(j,r)	    Output
    yd0(j,r)	    Output for domestic use
    ya0(j,r)	    Armington aggregates
    ijs0(i,j,s,r)   Intermediate inputs
    labs0(j,s,r)    Labor input
    lab0(r)	    Endowment of labor
    caps0(j,s,r)    Capital input
    cap0(r)	    Endowment of capital
    tys0(j,s,r)	    Indirect tax on output
    ty0(j,r)	    Indirect tax on output

    cs0(i,r,s)	    Consumption
    c0(*)	    Total consumption expenditure

    cps0(i,s,r)	    Private consumption,
    cp0(*)	    Private consumption

    cgs0(i,s,r)	    Government consumption,
    cg0(*)	    Government consumption,
    igs0(i,s,r)	    Government capital formation,
    ig0(*)	    Government capital formation,

    gexp0(*)	    Government expenditure
    gexps0(i,s,r)   Government expenditure

    invs0(i,s,r)    Capital formation,
    inv0(*)	    Capital formation,

    ex0(i,r)	    Exports,
    im0(i,r)	    Imports,
    tm0(i,r)	    Tariff rates
    tmm0(i,r)	    Rate of commodity tax on imported goods
    imw0	    Value of import (including tariffs + import commodity tax)
    imw_0	    Value of import (including only tariffs)
;
$ontext
Read data from GDX file.
$offtext
*	Import data:
$gdxin %data_name%

* $load i,r,ijs0,labs0,caps0,tys0,cps0,cgs0,igs0,invs0,ex0,im0,tm0,tmm0	# This does not work in old GAMS system.
$load i r ijs0 labs0 caps0 tys0 cps0 cgs0 igs0 invs0 ex0 im0 tm0 tmm0

display "com: Imported data";
display i, r, ijs0, labs0, caps0, tys0, cps0, cgs0, igs0, invs0, ex0, im0,
	tm0,tmm0;

*	Include set definition file:
$if exist %set_file% $include %set_file%

*	----------------------------------------------------------------------
*	Adjustment to government expenditure.
$ontext
fl_gov is non-zero
-> government expenditure is treated separately from private consumption.

fl_gov is zero
-> government consumption is aggregated into private consumption.
-> government investment is aggregated into private investment.

$offtext
if(fl_gov,
    cs0(i,s,r) = cps0(i,s,r);
    gexps0(i,s,r) = cgs0(i,s,r) + igs0(i,s,r);
else
    cs0(i,s,r) = cps0(i,s,r) + cgs0(i,s,r);
    invs0(i,s,r) = invs0(i,s,r) + igs0(i,s,r);
    gexps0(i,s,r) = 0;
    cps0(i,s,r) = 0;
    cgs0(i,s,r) = 0;
    igs0(i,s,r) = 0;
);
display cgs0, igs0, cs0, invs0, gexps0;

set	r_r(r,s)	"yes if r = s"
	r_s(r,s)	"yes if r is not equal to s"
;
r_r(r,s) = no;
r_r(r,r) = yes;
r_s(r,s) = yes;
r_s(r,r) = no;
display r_r, r_s;

*	----------------------------------------------------------------------
*	Adjustment to capital and land:
$ontext
If fl_land is non-zero
-> land is separated from capital.

sh_land		Share of land in land and capital in agricultural sector

sh_land is derived from GTAP6 data.
In GTAP6 data,
Capital input in agricultural sector in Japan = US$21986.3 mil.
Land input in agricultural sector in Japan = US$7552.7 mil.
$offtext
parameter
    sh_land		Share of land in land and capital in agricultural sector
    lnds0(j,s,r)	Land input
    lnd0(i,*)		Endowment of land
    caps0_old(j,s,r)
;
sh_land(j) = 0;
if(fl_land,
    sh_land("agr") = 7552.7 / (21986.3 + 7552.7);
);
display sh_land;

caps0_old(j,s,r) = caps0(j,s,r);
lnds0(j,r,r) = sh_land(j) * caps0_old(j,r,r);
caps0(j,r,r) = caps0(j,r,r) - lnds0(j,r,r);
display lnds0, caps0;

lnd0(i,r) = sum(s, lnds0(i,r,s));
lnd0(i,"sum") = sum(r, lnd0(i,r));
display lnd0;

*	Import tax data:
$include %tax_name%

*	Import elasticity parameters:
$include %elas_name%

$if %adj_tariff%==0 $goto end_adj_tariff
*	----------------------------------------------------------------------
*	Adjust tariff rates:
display "com: Adjust tariff rates:";
$ontext
֐ŗ̏CȂB
GTAPf[^ɍĊ֐ŗ㏸B
$offtext
display "Import and tariff data before adjustment", tm0, im0;

parameter
    org_rate		Original average tariff rate
    adjusted_rate	average rate of adjusted tariif
    imw_0_		Value of import (including tariffs)

    sc_m		Scale factor for adjusting import
    sc_t		Scale factor for adjusting tariff

    org_cs		Original consumption data
    org_ex		Original export data
    chk_ratio_ex
    chk_ratio_cs
;
display target_rate;

org_rate(i)$(sum(r, im0(i,r))) = sum(r, tm0(i,r)) / sum(r, im0(i,r));
display org_rate;

loop(i$target_rate(i),

    imw_0_(i,r,"org") = - (im0(i,r) + tm0(i,r));
    imw_0_(i,"sum","org") = sum(r, imw_0_(i,r,"org"));

    sc_m(i) = imw_0_(i,"sum","org") / ((1 + target_rate(i)) * sum(r, - im0(i,r)));
    sc_t(i) = target_rate(i) * sc_m(i) * sum(r, - im0(i,r)) / sum(r, - tm0(i,r));
*     display sc_m, sc_t;

    tm0(i,r) = sc_t(i) * tm0(i,r);
    im0(i,r) = sc_m(i) * im0(i,r);

    imw_0_(i,r,"adj") = - (im0(i,r) + tm0(i,r));
    imw_0_(i,r,"diff") = imw_0_(i,r,"adj") - imw_0_(i,r,"org");
    imw_0_(i,"sum","diff") = sum(r, imw_0_(i,r,"diff"));
*     display imw_0_;

    if(%adj_tariff_cons%,
*	adjustment by consumption
	display "Adjust consumption";
	org_cs(i,r,s) = cs0(i,r,s);
	cs0(i,r,r) = cs0(i,r,r) + imw_0_(i,r,"diff");
	chk_ratio_cs(i,r)
	    = 100 * (sum(s, cs0(i,s,r)) / sum(s, org_cs(i,s,r)) - 1);
	display cs0, chk_ratio_cs;
    else
*	adjustment by export
	display "Adjust export";
	org_ex(i,r) = ex0(i,r);
	ex0(i,r) = ex0(i,r) + imw_0_(i,r,"diff");
	chk_ratio_ex(i,r) = 100 * (org_ex(i,r) / ex0(i,r) - 1);
	display ex0, chk_ratio_ex;
    );
);

display "Import and tariff data after adjustment", tm0, im0;

adjusted_rate(i)$(sum(r, im0(i,r))) = sum(r, tm0(i,r)) / sum(r, im0(i,r));
display adjusted_rate;

$label end_adj_tariff

im0(i,r) = - im0(i,r);
tm0(i,r) = - tm0(i,r);
tmm0(i,r) = - tmm0(i,r);
imw_0(i,r) = im0(i,r) + tm0(i,r);
imw0(i,r) = im0(i,r) + tm0(i,r) + tmm0(i,r);
imw_0(i,"sum") = sum(r, imw_0(i,r));
imw_0("sum",r) = sum(i, imw_0(i,r));
imw_0("sum","sum") = sum((i,r), imw_0(i,r));
imw0(i,"sum") = sum(r, imw0(i,r));
imw0("sum",r) = sum(i, imw0(i,r));
imw0("sum","sum") = sum((i,r), imw0(i,r));
display imw_0, imw0;

parameter
    tax_rate		Rate of tariff and import commodity tax
;
tax_rate(i,r,"tariff")$im0(i,r) = tm0(i,r) / im0(i,r);
tax_rate(i,r,"imptax")$im0(i,r) = tmm0(i,r) / im0(i,r);
display tax_rate;

*	----------------------------------------------------------------------
*	Define parameters:
display "com: Define parameters:";

*	Value of output at market price:
y0(j,r) = sum((i,s), ijs0(i,j,s,r))
    + sum(s, labs0(j,s,r)) + sum(s, caps0(j,s,r))
    + sum(s, lnds0(j,s,r))
    + sum(s, tys0(j,s,r));

*	Domestic supply:
yd0(j,r) = y0(j,r) - ex0(j,r);

*	Armington supply = domestic supply + import supply:
ya0(j,r) = yd0(j,r) + im0(j,r) + tm0(j,r);

*	Consumption:
c0(r)	= sum((i,s), cs0(i,s,r));
c0("sum")   = sum(r, c0(r));

*	Capital formation:
inv0(r)	 = sum((i,s), invs0(i,s,r));
inv0("Sum") = sum(r, inv0(r));

*	Government expenditure:
gexp0(r) = sum((i,s), gexps0(i,s,r));
gexp0("sum") = sum(r, gexp0(r));

display y0, yd0, ya0, c0, gexp0, inv0;

set	rnum(r)		Numeraire region (the region with the largest consumption);
rnum(r) = yes$(c0(r) = smax(s, c0(s)));
display rnum;

*	-----------------------------------------------------------------
*	Tax:
parameter
    taxy0(j,r)	  Output tax rate,
    taxm0(j,r)	  "Tariff + import commodity tax rate",

    py0(j,r)	  Output price tax excluded,
    pl0(r)	  Labor cost tax included,
    pk0(r)	  Capital cost tax included,
    pm0(j,r)	  Import price tax included
;
taxy0(j,r)$y0(j,r)  = sum(s, tys0(j,s,r))/y0(j,r);
py0(j,r) = 1 - taxy0(j,r);

labs0(j,s,r) = labs0(j,s,r) * (1 - taxl0(s));
lab0(r)	= sum((j,s), labs0(j,r,s));
taxl0(r) = taxl0(r) / (1 - taxl0(r));
pl0(r) = 1 + taxl0(r);

caps0(j,s,r) = caps0(j,s,r) * (1 - taxk0(s));
cap0(r) = sum((j,s), caps0(j,r,s));
taxk0(r) = taxk0(r) / (1 - taxk0(r));
pk0(r) = 1 + taxk0(r);

taxm0(j,r)$im0(j,r) = (tm0(j,r) + tmm0(j,r)) / im0(j,r);
pm0(j,r) = 1 + taxm0(j,r);
display taxy0, taxm0;
display py0, pl0, pk0, pm0;
display taxl0, taxk0, labs0, labs0, caps0, cap0;

parameter
    t_labs0(j,r)	Total labor input of sector j in region r
    t_caps0(j,r)	Total capital input of sector j in region r
    t_lnds0(j,r)	Total land input of sector j in region r
;
t_labs0(j,r) = sum(s, pl0(s) * labs0(j,s,r));
t_caps0(j,r) = sum(s, pk0(s) * caps0(j,s,r));
t_lnds0(j,r) = sum(s, lnds0(j,s,r));
display t_labs0, t_caps0, t_lnds0;

*	----------------------------------------------------------------------
*	Saving and transfer
Parameters
    hsave0(*)	  Household saving
    bop0(*)	  Balance of payment
    trn0(*)	  Transfer income to each region from the central government
    hexp0(*)	  Household total expenditure
;
*	BOP = export - import:
bop0(r)	= sum(i, ex0(i,r) - im0(i,r));
bop0("sum") = sum(r, bop0(r));
if((not fl_bop), bop0(r) = 0);
display bop0;

*	Transfer to each region = consumption + investment + BOP surplus - factor income:
trn0(r) = c0(r) + inv0(r) + gexp0(r) + bop0(r) - (lab0(r) + cap0(r) + sum(i, lnd0(i,r)));
trn0("sum") = sum(r, trn0(r));
display trn0;

*	Total expenditure of household:
hexp0(r) = c0(r) + inv0(r);
display hexp0;

*	----------------------------------------------------------------------
*	Parameters for policy analysis:
display "com: Parameters for policy analysis:";

parameter
    s_f			Scale parameter
    e_trade(i,r)	Efficiency parameters
    e_tot(i,r)		TOT parameter
;
s_f = 1;
e_trade(i,r) = 1;
e_tot(i,r) = 1;
display s_f, e_trade;

*	----------------------------------------------------------------------
*	Parameters for Armington aggregation:
parameter
    a0(i,r)		Armington goods (by regions)
    ad0(i,r)		Aggregated domestic goods (by regions)

    sup_dom0		Domestic supply
    sup_imp0		Import supply
    sup_tot0		Total supply

    t_ijs0(i,j,r)	Intermediate inputs
    t_cs0(i,r)		Consumption
    t_invs0(i,r)	Investment
    t_gexps0(i,r)	Government expenditure
;
sup_imp0(i,r) = imw0(i,r);
sup_dom0(i,s,r) = sum(j, ijs0(i,j,s,r)) + cs0(i,s,r) + invs0(i,s,r) + gexps0(i,s,r);
sup_dom0(i,r,r) = sum(j, ijs0(i,j,r,r)) + cs0(i,r,r) + invs0(i,r,r) + gexps0(i,r,r) - sup_imp0(i,r);
sup_dom0(i,r,s) = round(sup_dom0(i,r,s), 8);
sup_tot0(i,r) = sup_imp0(i,r) + sum(s, sup_dom0(i,s,r));
display sup_imp0, sup_dom0, sup_tot0;

loop((i,r,s),
    abort$(sup_imp0(i,r) < 0) "Inconsistent data!!!", sup_imp0;
    abort$(sup_dom0(i,s,r) < 0) "Inconsistent data!!!", sup_dom0;
);

a0(i,r) = sup_tot0(i,r);
ad0(i,r) = sum(s, sup_dom0(i,s,r));
display a0, ad0;

t_ijs0(i,j,r) = sum(s, ijs0(i,j,s,r));
t_cs0(i,r) = sum(s, cs0(i,s,r));
t_invs0(i,r) = sum(s, invs0(i,s,r));
t_gexps0(i,r) = sum(s, gexps0(i,s,r));
display t_ijs0, t_cs0, t_invs0, t_gexps0;

*	----------------------------------------------------------------------
*	Import population data:
$include %pop_file%

$ontext
Model definition.
$offtext
*	----------------------------------------------------------------------
*	MPSGE model
$include .\model_mpsge.gms

*	----------------------------------------------------------------------
*	MCP model:
$include .\model_mcp.gms

*	----------------------------------------------------------------------
*	Import parameters used for displaying results:
$include .\parameters_for_results.gms
fl_bau = 1;

*	----------------------------------------------------------------------
*	Benchmark replication.
display "com: Benchmark replication";
if(%solve_mpsge%,
    mrm_jpn_mpsge.workspace = 500;
    mrm_jpn_mpsge.iterlim=0;
$include mrm_jpn_mpsge.gen
    solve mrm_jpn_mpsge using mcp;
);

if(%solve_mcp%,
    mrm_jpn_mcp.workspace = 500;
    mrm_jpn_mcp.iterlim=0;
    solve mrm_jpn_mcp using mcp;
);
$if not %br_only%==0 $goto end

*	----------------------------------------------------------------------
*	Cleanup calculation.
display "com: Cleanup calculation";
if(%solve_mpsge%,
    mrm_jpn_mpsge.iterlim=10000;
$include mrm_jpn_mpsge.gen
    solve mrm_jpn_mpsge using mcp;
);

if(%solve_mcp%,
    mrm_jpn_mcp.iterlim=10000;
    solve mrm_jpn_mcp using mcp;
);

$if not %solve_mpsge%==0 $include .\output_results_mpsge.gms
$if not %solve_mcp%==0 $include .\output_results_mcp.gms

$if not %cc_only%==0 $goto end

if(%scale_shock%,
*	----------------------------------------------------------------------
*	Scale shock experiment
    display "com: Scale shock experiment";
    s_f = 1 + %scale_shock% / 100;
    display s_f;
    if(%solve_mpsge%,
$include mrm_jpn_mpsge.gen
	solve mrm_jpn_mpsge using mcp;
	fl_bau = 0;
    );
    if(%solve_mcp%,
	solve mrm_jpn_mcp using mcp;
	fl_bau = 0;
    );
);

fl_bau = 0;
$if not %solve_mpsge%==0 $include .\output_results_mpsge.gms
$if not %solve_mcp%==0 $include .\output_results_mcp.gms

s_f = 1;
$if not %scale_shock%==0 $goto report

*	----------------------------------------------------------------------
*	Trade liberalization experiment:
display "com: Trade liberalization experiment";

$if not %fl_tot%==0 $include %tot_file%
display e_tot;

$if not %fl_service%==0 $include %service_file%
display e_trade;

*	Set tariff rates to zero:
$ontext
taxm ̒́u֐ŗv̕DuAiŁv̐ŗ͂̂܂܁D
$offtext
taxm0(j,r) = taxm0(j,r) - tax_rate(j,r,"tariff");
display taxm0;

if(%solve_mpsge%,
$include mrm_jpn_mpsge.gen
    solve mrm_jpn_mpsge using mcp;
    abort$(mrm_jpn_mpsge.modelstat ne 1) "Abort!!! Model Status is not 1", mrm_jpn_mpsge.modelstat;
    abort$(mrm_jpn_mpsge.solvestat ne 1) "Abort!!! Solve Status is not 1", mrm_jpn_mpsge.solvestat;
);

fl_bau = 0;
$if not %solve_mpsge%==0 $include .\output_results_mpsge.gms

if(%solve_mcp%,
    solve mrm_jpn_mcp using mcp;
    abort$(mrm_jpn_mcp.modelstat ne 1) "Abort!!! Model Status is not 1", mrm_jpn_mcp.modelstat;
    abort$(mrm_jpn_mcp.solvestat ne 1) "Abort!!! Solve Status is not 1", mrm_jpn_mcp.solvestat;
);

fl_bau = 0;
$if not %solve_mcp%==0 $include .\output_results_mcp.gms

$label report

$include .\output_results.gms

$include .\output_results_to_excel.gms

$label end

* --------------------
* local variables:
* mode: gams
* fill-column: 80
* end:
