$ontext
Time-stamp:	<2008-06-03 18:29:10 Shiro Takeda>

Model written in MPSGE format:

$offtext

$ontext

$model:mrm_jpn_mpsge

*	Debug options for MPSGE
* $echop:.true.
* $datech:.true.
* $funlog:.true.

$sectors:
    y(i,r)$y0(i,r)		! Production
    a(i,r)			! Armington aggregation (top level, by region)
    ad(i,r)$ad0(i,r)		! Aggregation of domestic goods (by region)
    ak(i,r)$t_caps0(i,r)	! Aggregation of capital
    al(i,r)$t_labs0(i,r)	! Aggregation of labor
    im(i,r)$im0(i,r)		! Import
    ex(i,r)$ex0(i,r)		! Export
    c(r)			! Consumption
    inv(r)			! Capital formation
    g				! Transfer to regions
    u(r)			! Utility
    gov(r)$fl_gov		! Government expenditure

$commodities:
    pd(i,r)$y0(i,r)		! Price of output for domestic use
    pa(i,r)			! Price of Armington goods (by region)
    pad(i,r)$ad0(i,r)		! Price of aggregated domestic goods (by region)
    pm(i,r)$im0(i,r)		! Price of import
    px(i,r)$ex0(i,r)		! Price of export
    pc(r)			! Price of consumption
    pinv(r)			! Price of capital formation
    pl(r)			! Wage rate
    pk(r)			! Capital cost
    pland(i,r)$t_lnds0(i,r)	! Price of land
    pfx				! Price of foreign exchange
    pg				!
    pu(r)			! Price of utility
    pak(i,r)$t_caps0(i,r)	! Price of aggregated capital
    pal(i,r)$t_labs0(i,r)	! Price of aggregated labor
    pgov(r)$fl_gov		! Price index of government expenditure

$consumers:
    m_h(r)			! Household agent
    m_g				! Central government

$auxiliary:
    c_endow			! Endowment (dummy variable for transfer)

*	Production:
$prod:y(i,r)$ex0(i,r)  t:etra(i)  s:elas_vai(i)	 va(s):elas_va(i)
    o:pd(i,r)	q:yd0(i,r)	p:py0(i,r)	a:m_g t:taxy0(i,r)
    o:px(i,r)	q:ex0(i,r)	p:py0(i,r)	a:m_g t:taxy0(i,r)
    i:pa(j,r)	q:t_ijs0(j,i,r)
    i:pal(i,r)	q:t_labs0(i,r)	va:
    i:pak(i,r)	q:t_caps0(i,r)	va:
    i:pland(i,r)	q:t_lnds0(i,r)	va:

*	Production without export:
$prod:y(i,r)$(y0(i,r) and (not ex0(i,r)))  s:elas_vai(i)  va(s):elas_va(i)
    o:pd(i,r)	q:y0(i,r)	p:py0(i,r)	a:m_g t:taxy0(i,r)
    i:pa(j,r)	q:t_ijs0(j,i,r)
    i:pal(i,r)	q:t_labs0(i,r)	va:
    i:pak(i,r)	q:t_caps0(i,r)	va:

*	Aggregation of capital:
$prod:ak(i,r)$t_caps0(i,r)  s:elas_k(i)
    o:pak(i,r)	q:t_caps0(i,r)
    i:pk(s)	q:caps0(i,s,r)	p:pk0(s)	a:m_g t:taxk0(s)

*	Aggregation of labor:
$prod:al(i,r)$t_labs0(i,r) s:elas_l(i)
    o:pal(i,r)	q:t_labs0(i,r)
    i:pl(s)	q:labs0(i,s,r)	p:pl0(s)	a:m_g t:taxl0(s)

*	Armington aggregation:
$prod:a(i,r)$a0(i,r)  s:elas_dm(i)
    o:pa(i,r)	q:a0(i,r)
    i:pm(i,r)	q:sup_imp0(i,r)
    i:pad(i,r)	q:ad0(i,r)

*	Aggregation of domestic goods:
$prod:ad(i,r)$ad0(i,r)	s:elas_dd(i)
    o:pad(i,r)	q:ad0(i,r)
    i:pd(i,s)	q:sup_dom0(i,s,r)

*	Import activity:
$prod:im(i,r)$im0(i,r)
    o:pm(i,r)	q:(imw0(i,r)*e_trade(i,r))
    i:pfx	q:(im0(i,r))	p:pm0(i,r)	a:m_g t:taxm0(i,r)

*	Export activity:
$prod:ex(i,r)$ex0(i,r)
    o:pfx	q:(ex0(i,r)*e_tot(i,r)*e_trade(i,r))
    i:px(i,r)	q:ex0(i,r)

*	Consumption:
$prod:c(r)  s:elas_c
    o:pc(r)	q:c0(r)
    i:pa(i,r)	q:t_cs0(i,r)

*	Utility:
$prod:u(r)  s:elas_u
    o:pu(r)$(not fix_inv)	q:hexp0(r)
    o:pu(r)$fix_inv		q:c0(r)
    i:pc(r)			q:c0(r)
    i:pinv(r)$(not fix_inv)	q:inv0(r)

*	Investment:
$prod:inv(r)  s:elas_inv
    o:pinv(r)	q:inv0(r)
    i:pa(i,r)	q:t_invs0(i,r)

*	Government expenditure:
$prod:gov(r)$fl_gov	s:elas_g
    o:pgov(r)	q:gexp0(r)
    i:pa(i,r)	q:t_gexps0(i,r)

*	Central government (dummy sector to incorporate transfer)
$prod:g	 s:0
    o:pg	q:trn0("sum")
    i:pc(rnum)	q:trn0("sum")

*	Income of the regional household:
$demand:m_h(r)
    d:pu(r)$(not fix_inv) q:hexp0(r)
    d:pu(r)$fix_inv	q:c0(r)
    e:pinv(r)$fix_inv	q:(-s_f*inv0(r))
    e:pl(r)		q:(s_f*lab0(r))
    e:pk(r)		q:(s_f*cap0(r))
    e:pland(i,r)	q:(s_f*lnd0(i,r))
    e:pfx		q:(-s_f*bop0(r))
    e:pc(rnum)		q:(trn0(r))	r:c_endow
    e:pgov(r)		q:(-s_f*gexp0(r))

*	Income of the central government
$demand:m_g
    d:pg	q:trn0("sum")
    e:pfx$(not fl_bop)	q:(-s_f*bop0("sum"))

*	Auxiliary variable for transfer:
$constraint:c_endow
    c_endow =e= g;

$report:
    v:q_c(r)	o:pc(r)	prod:c(r) 				! Consumption
    v:q_save(r)$(not fix_inv)	i:pinv(r)	prod:u(r)	! Saving
    v:q_inv(r)	o:pinv(r)	prod:inv(r)			! Investment
    v:q_gov(r)$fl_gov		o:pgov(r)	prod:gov(r)	! Government expenditure
    v:q_exx(i,r)	o:pfx	prod:ex(i,r)			! Export
    v:q_ex(i,r)		i:px(i,r)	prod:ex(i,r)		! Export
    v:q_im(i,r)		i:pfx		prod:im(i,r)		! Import
    v:q_imw(i,r)	o:pm(i,r)	prod:im(i,r)		! Import
    v:q_l(i,s,r)	i:pl(s)		prod:al(i,r)		! Labor input
    v:q_k(i,s,r)	i:pk(s)		prod:ak(i,r)		! Capital input
    v:q_al(i,r)		i:pal(i,r)	prod:y(i,r)		! Labor
    v:q_ak(i,r)		i:pak(i,r)	prod:y(i,r)		! Capital
    v:q_es(i,r)$ex0(i,r)		o:px(i,r)	prod:y(i,r) ! Export supply
    v:q_ds(i,r)	  o:pd(i,r)		prod:y(i,r)		    ! Domestic supply
    v:q_a_d(i,s,r)	i:pd(i,s)	prod:ad(i,r)		    ! Domestic supply

$offtext

$sysinclude mpsgeset mrm_jpn_mpsge

*	Initial value:
c_endow.l = 1;

* --------------------
* Local Variables:
* mode: gams
* fill-column: 80
* End:
