$ontext
Time-stamp: 	<2008-06-03 17:29:38 Shiro Takeda>
$offtext

*	----------------------------------------------------------------------
*	Results:

if(fl_bau,
*	Result in BAU equilibrium:

    chk_walras(r,"bau") = 100 * m_h_.m(r) / m_h_.l(r);

*	Consumption:
    l_c(r,"bau") = c0(r) * c_.l(r);
    l_c("sum","bau") = sum(r, l_c(r,"bau"));

*	EV
    l_ev(r,"bau") = (u_.l(r) - 1) * (hexp0(r)$(not fix_inv) + c0(r)$fix_inv);
    l_ev("sum","bau") = sum(r, l_ev(r,"bau"));

*	Utility:
    l_u(r,"bau") = (hexp0(r)$(not fix_inv) + c0(r)$fix_inv) * u_.l(r);
    l_u("sum","bau") = sum(r, l_u(r,"bau"));

*	Savings:
    l_save(r,"bau") = (a_s_.l(r) * u_.l(r))$(not fix_inv) + (s_f * inv0(r))$fix_inv;
    l_save("sum","bau") = sum(r, l_save(r,"bau"));

*	Government expenditure:
    l_gov(r,"bau") = gexp0(r) * gov_.l(r);
    l_gov("sum","bau") = sum(r, l_gov(r,"bau"));

*	Export:
    l_exp_r(r,"bau") = sum(i, exx_.l(i,r));

*	Import
    l_imp_r(r,"bau") = sum(i, imw0(i,r) * im_.l(i,r));

*	Export by goods:
    l_exp_g(i,"bau") = sum(r, exx_.l(i,r));

*	Import by goods
    l_imp_g(i,"bau") = sum(r, imw0(i,r) * im_.l(i,r));

*	Production level:
    l_y(i,r,"bau") = y0(i,r) * y_.l(i,r);

*	Transfer to regions:
    l_trans(r,"bau") = sh_t(r) * m_g_.l;
    l_trans("sum","bau") = sum(r, l_trans(r,"bau"));

*	Factor prices:
    l_pl(r,"bau") = p_l_.l(r) / p_u_.l(r);
    l_pk(r,"bau") = p_k_.l(r) / p_u_.l(r);
    l_pland(r,"bau") = p_land_.l("agr",r) / p_u_.l(r);

*	External TOT:
    l_sh_ex(i,r,"bau")
	= p_x_.l(i,r) * ex0(i,r) * ex_.l(i,r) / sum(ii, p_x_.l(ii,r) * ex0(ii,r) * ex_.l(ii,r));
    l_sh_im(i,r,"bau")
	= p_fx_.l * im0(i,r) * im_.l(i,r) / sum(ii, p_fx_.l * im0(ii,r) * im_.l(ii,r));
    l_p_ex(r,"bau") = prod(i$ex0(i,r), p_x_.l(i,r)**(sum(scn, 0.5*l_sh_ex(i,r,scn))));
    l_p_im(r,"bau") = prod(i$im0(i,r), p_fx_.l**(sum(scn, 0.5*l_sh_im(i,r,scn))));
    l_tot(r,"bau") = l_p_ex(r,"bau") / l_p_im(r,"bau");

*	TOT (including domestic trade):
    l_sh_ex_alt(i,r,"d","bau")
	= p_d_.l(i,r) * sum(s$r_s(r,s), a_d_.l(i,r,s) * ad_.l(i,s))
	/ (sum(ii, p_x_.l(ii,r) * ex0(ii,r) * ex_.l(ii,r)
	+ sum(s$r_s(r,s), p_d_.l(ii,r) * a_d_.l(ii,r,s) * ad_.l(ii,s))));
    l_sh_ex_alt(i,r,"f","bau")
	= (p_x_.l(i,r) * ex0(i,r) * ex_.l(i,r))
	/ (sum(ii, p_x_.l(ii,r) * ex0(ii,r) * ex_.l(ii,r)
	+ sum(s$r_s(r,s), p_d_.l(ii,r) * a_d_.l(ii,r,s) * ad_.l(ii,s))));
    l_sh_im_alt(i,s,r,"bau")
	= (p_d_.l(i,s) * a_d_.l(i,s,r) * ad_.l(i,r))
	/ (sum(ii, p_fx_.l * im0(ii,r) * im_.l(ii,r)
	+ sum(rr$r_s(r,rr), p_d_.l(ii,rr) * a_d_.l(ii,rr,r) * ad_.l(ii,r))));
    l_sh_im_alt(i,"f",r,"bau")
	= (p_fx_.l * im0(i,r) * im_.l(i,r))
	/ (sum(ii, p_fx_.l * im0(ii,r) * im_.l(ii,r)
	+ sum(s$r_s(r,s), p_d_.l(ii,s) * a_d_.l(ii,s,r) * ad_.l(ii,r))));
    l_p_ex_alt(r,"bau") =
	prod(i$ex0(i,r), p_x_.l(i,r)**(sum(scn, 0.5*l_sh_ex_alt(i,r,"f",scn))))
	* prod(i$l_sh_ex_alt(i,r,"d","bau"), p_d_.l(i,r)**(sum(scn, 0.5*l_sh_ex_alt(i,r,"d",scn))));
    l_p_im_alt(r,"bau") =
	prod(i$im0(i,r), p_fx_.l**(sum(scn, 0.5*l_sh_im_alt(i,"f",r,scn))))
	* prod((i,s)$l_sh_im_alt(i,s,r,"bau"), p_d_.l(i,s)**(sum(scn, 0.5*l_sh_im_alt(i,s,r,scn))));
    l_tot_alt(r,"bau") = l_p_ex_alt(r,"bau") / l_p_im_alt(r,"bau");

*	GDP (value added):
    l_vgdp_va(r,"bau")
	= sum(j, p_al_.l(j,r) * a_al_.l(j,r) * y_.l(j,r)
	+ p_ak_.l(j,r) * a_ak_.l(j,r) * y_.l(j,r)
	+ p_land_.l(j,r) * a_land_.l(j,r) * y_.l(j,r)
	+ taxy0(j,r) * p_y_.l(j,r) * y0(j,r) * y_.l(j,r));
    l_vgdp_va("sum","bau") = sum(r, l_vgdp_va(r,"bau"));

*	Decomposition of utility change:
    l_u_decomp(r,"finc","bau")
	= (p_l_.l(r) * s_f * lab0(r) + p_k_.l(r) * s_f * cap0(r)
	+ sum(i$lnd0(i,r), p_land_.l(i,r) * s_f * lnd0(i,r))) / p_u_.l(r);
    l_u_decomp(r,"trns","bau")
	= ((sh_t(r) * m_g_.l)$(not fl_redis) + trans_.l(r)$fl_redis) / p_u_.l(r);
    l_u_decomp(r,"oth","bau")
	= - ((p_fx_.l * s_f * bop0(r))$fl_bop
	+ (p_inv_.l(r) * s_f * inv0(r))$fix_inv
	+ p_gov_.l(r) * s_f * gexp0(r)) / p_u_.l(r);
    l_u_decomp(r,"sum","bau")
	= l_u_decomp(r,"finc","bau") + l_u_decomp(r,"trns","bau") + l_u_decomp(r,"oth","bau");
    l_u_decomp("sum","finc","bau") = sum(r, l_u_decomp(r,"finc","bau"));
    l_u_decomp("sum","trns","bau") = sum(r, l_u_decomp(r,"trns","bau"));
    l_u_decomp("sum","oth","bau") = sum(r, l_u_decomp(r,"oth","bau"));
    l_u_decomp("sum","sum","bau") = sum(r, l_u_decomp(r,"sum","bau"));
    display l_u_decomp;

*	Share of individual component in utility:
    l_u_sh(r,"finc","bau")
	= l_u_decomp(r,"finc","bau") / l_u_decomp(r,"sum","bau");
    l_u_sh(r,"trns","bau")
	= l_u_decomp(r,"trns","bau") / l_u_decomp(r,"sum","bau");
    l_u_sh(r,"oth","bau")
	= l_u_decomp(r,"oth","bau") / l_u_decomp(r,"sum","bau");
    l_u_sh("sum","finc","bau")
	= l_u_decomp("sum","finc","bau") / l_u_decomp("sum","sum","bau");
    l_u_sh("sum","trns","bau")
	= l_u_decomp("sum","trns","bau") / l_u_decomp("sum","sum","bau");
    l_u_sh("sum","oth","bau")
	= l_u_decomp("sum","oth","bau") / l_u_decomp("sum","sum","bau");

*	BOP:
    l_bop(r,"bau") =
	sum(i$ex0(i,r), exx_.l(i,r))
	- sum(i$im0(i,r), im0(i,r) * im_.l(i,r));
    l_bop("sum","bau") = sum(r, l_bop(r,"bau"));

*	GDP (expenditure side):
    l_vgdp(r,"bau") =
	p_c_.l(r) * c0(r) * c_.l(r)
	+ p_gov_.l(r) * gexp0(r) * gov_.l(r)
	+ p_inv_.l(r) * inv0(r) * inv_.l(r)
	+ sum(i, p_fx_.l * exx_.l(i,r))
 	- sum(i, pm0(i,r) * p_m_.l(i,r) * im0(i,r) * im_.l(i,r))
	+ sum((i,s)$r_s(r,s), p_d_.l(i,r) * a_d_.l(i,r,s) * ad_.l(i,s))
	- sum((i,s)$r_s(r,s), p_d_.l(i,s) * a_d_.l(i,s,r) * ad_.l(i,r))
	;
    l_vgdp("sum","bau") = sum(r, l_vgdp(r,"bau"));

*	Real GDP:
    l_qgdp(r,"bau") =
	c0(r) * c_.l(r)
	+ gexp0(r) * gov_.l(r)
	+ inv0(r) * inv_.l(r)
	+ sum(i, exx_.l(i,r))
 	- sum(i, im0(i,r) * im_.l(i,r))
	+ sum((i,s)$r_s(r,s), a_d_.l(i,r,s) * ad_.l(i,s))
	- sum((i,s)$r_s(r,s), a_d_.l(i,s,r) * ad_.l(i,r))
	;
    l_qgdp("sum","bau") = sum(r, l_qgdp(r,"bau"));

*	Price index of GDP (derived implicitly):
    l_pgdp(r,"bau") = l_vgdp(r,"bau") / l_qgdp(r,"bau");

*	Decomposition of GDP change:
    l_qgdp_decomp_ele(r,"con","bau") = c0(r) * c_.l(r);
    l_qgdp_decomp_ele(r,"gov","bau") = gexp0(r) * gov_.l(r);
    l_qgdp_decomp_ele(r,"inv","bau") = inv0(r) * inv_.l(r);
    l_qgdp_decomp_ele(r,"exp","bau") = sum(i, exx_.l(i,r));
    l_qgdp_decomp_ele(r,"imp","bau") = - sum(i, im0(i,r) * im_.l(i,r));
    l_qgdp_decomp_ele(r,"out","bau")
	= sum((i,s)$r_s(r,s), a_d_.l(i,r,s) * ad_.l(i,s));
    l_qgdp_decomp_ele(r,"in","bau")
	= - sum((i,s)$r_s(r,s), a_d_.l(i,s,r) * ad_.l(i,r));
    l_qgdp_decomp_ele(r,"sum","bau")
	= sum(ele_gdp, l_qgdp_decomp_ele(r,ele_gdp,"bau"));
    l_qgdp_decomp_ele("sum",ele_gdp,"bau")  = sum(r, l_qgdp_decomp_ele(r,ele_gdp,"bau"));
    l_qgdp_decomp_ele("sum","sum","bau")  = sum((r,ele_gdp), l_qgdp_decomp_ele(r,ele_gdp,"bau"));

else

    chk_walras(r,"cf") = 100 * m_h_.m(r) / m_h_.l(r);

*	Consumption:
    l_c(r,"cf") = c0(r) * c_.l(r);
    l_c("sum","cf") = sum(r, l_c(r,"cf"));

*	EV
    l_ev(r,"cf") = (u_.l(r) - 1) * (hexp0(r)$(not fix_inv) + c0(r)$fix_inv);
    l_ev("sum","cf") = sum(r, l_ev(r,"cf"));

*	Utility:
    l_u(r,"cf") = (hexp0(r)$(not fix_inv) + c0(r)$fix_inv) * u_.l(r);
    l_u("sum","cf") = sum(r, l_u(r,"cf"));

*	Savings:
    l_save(r,"cf") = (a_s_.l(r) * u_.l(r))$(not fix_inv) + (s_f * inv0(r))$fix_inv;
    l_save("sum","cf") = sum(r, l_save(r,"cf"));

*	Government expenditure:
    l_gov(r,"cf") = gexp0(r) * gov_.l(r);
    l_gov("sum","cf") = sum(r, l_gov(r,"cf"));

*	Export:
    l_exp_r(r,"cf") = sum(i, exx_.l(i,r));

*	Import
    l_imp_r(r,"cf") = sum(i, imw0(i,r) * im_.l(i,r));

*	Export by goods:
    l_exp_g(i,"cf") = sum(r, exx_.l(i,r));

*	Import by goods
    l_imp_g(i,"cf") = sum(r, imw0(i,r) * im_.l(i,r));

*	Production level:
    l_y(i,r,"cf") = y0(i,r) * y_.l(i,r);

*	Transfer to regions:
    l_trans(r,"cf") = sh_t(r) * m_g_.l;
    l_trans("sum","cf") = sum(r, l_trans(r,"cf"));

*	Factor prices:
    l_pl(r,"cf") = p_l_.l(r) / p_u_.l(r);
    l_pk(r,"cf") = p_k_.l(r) / p_u_.l(r);
    l_pland(r,"cf") = p_land_.l("agr",r) / p_u_.l(r);

*	External TOT:
    l_sh_ex(i,r,"cf")
	= p_x_.l(i,r) * ex0(i,r) * ex_.l(i,r) / sum(ii, p_x_.l(ii,r) * ex0(ii,r) * ex_.l(ii,r));
    l_sh_im(i,r,"cf")
	= p_fx_.l * im0(i,r) * im_.l(i,r) / sum(ii, p_fx_.l * im0(ii,r) * im_.l(ii,r));
    l_p_ex(r,"cf") = prod(i$ex0(i,r), p_x_.l(i,r)**(sum(scn, 0.5*l_sh_ex(i,r,scn))));
    l_p_im(r,"cf") = prod(i$im0(i,r), p_fx_.l**(sum(scn, 0.5*l_sh_im(i,r,scn))));
    l_tot(r,"cf") = l_p_ex(r,"cf") / l_p_im(r,"cf");

*	TOT (including domestic trade):
    l_sh_ex_alt(i,r,"d","cf")
	= p_d_.l(i,r) * sum(s$r_s(r,s), a_d_.l(i,r,s) * ad_.l(i,s))
	/ (sum(ii, p_x_.l(ii,r) * ex0(ii,r) * ex_.l(ii,r)
	+ sum(s$r_s(r,s), p_d_.l(ii,r) * a_d_.l(ii,r,s) * ad_.l(ii,s))));
    l_sh_ex_alt(i,r,"f","cf")
	= (p_x_.l(i,r) * ex0(i,r) * ex_.l(i,r))
	/ (sum(ii, p_x_.l(ii,r) * ex0(ii,r) * ex_.l(ii,r)
	+ sum(s$r_s(r,s), p_d_.l(ii,r) * a_d_.l(ii,r,s) * ad_.l(ii,s))));
    l_sh_im_alt(i,s,r,"cf")
	= (p_d_.l(i,s) * a_d_.l(i,s,r) * ad_.l(i,r))
	/ (sum(ii, p_fx_.l * im0(ii,r) * im_.l(ii,r)
	+ sum(rr$r_s(r,rr), p_d_.l(ii,rr) * a_d_.l(ii,rr,r) * ad_.l(ii,r))));
    l_sh_im_alt(i,"f",r,"cf")
	= (p_fx_.l * im0(i,r) * im_.l(i,r))
	/ (sum(ii, p_fx_.l * im0(ii,r) * im_.l(ii,r)
	+ sum(s$r_s(r,s), p_d_.l(ii,s) * a_d_.l(ii,s,r) * ad_.l(ii,r))));
    l_p_ex_alt(r,"cf") =
	prod(i$ex0(i,r), p_x_.l(i,r)**(sum(scn, 0.5*l_sh_ex_alt(i,r,"f",scn))))
	* prod(i$l_sh_ex_alt(i,r,"d","cf"), p_d_.l(i,r)**(sum(scn, 0.5*l_sh_ex_alt(i,r,"d",scn))));
    l_p_im_alt(r,"cf") =
	prod(i$im0(i,r), p_fx_.l**(sum(scn, 0.5*l_sh_im_alt(i,"f",r,scn))))
	* prod((i,s)$l_sh_im_alt(i,s,r,"cf"), p_d_.l(i,s)**(sum(scn, 0.5*l_sh_im_alt(i,s,r,scn))));
    l_tot_alt(r,"cf") = l_p_ex_alt(r,"cf") / l_p_im_alt(r,"cf");

*	GDP (value added):
    l_vgdp_va(r,"cf")
	= sum(j, p_al_.l(j,r) * a_al_.l(j,r) * y_.l(j,r)
	+ p_ak_.l(j,r) * a_ak_.l(j,r) * y_.l(j,r)
	+ p_land_.l(j,r) * a_land_.l(j,r) * y_.l(j,r)
	+ taxy0(j,r) * p_y_.l(j,r) * y0(j,r) * y_.l(j,r));
    l_vgdp_va("sum","cf") = sum(r, l_vgdp_va(r,"cf"));

*	Decomposition of utility change:
    l_u_decomp(r,"finc","cf")
	= (p_l_.l(r) * s_f * lab0(r) + p_k_.l(r) * s_f * cap0(r)
	+ sum(i$lnd0(i,r), p_land_.l(i,r) * s_f * lnd0(i,r))) / p_u_.l(r);
    l_u_decomp(r,"trns","cf")
	= ((sh_t(r) * m_g_.l)$(not fl_redis) + trans_.l(r)$fl_redis) / p_u_.l(r);
    l_u_decomp(r,"oth","cf")
	= - ((p_fx_.l * s_f * bop0(r))$fl_bop
	+ (p_inv_.l(r) * s_f * inv0(r))$fix_inv
	+ p_gov_.l(r) * s_f * gexp0(r)) / p_u_.l(r);
    l_u_decomp(r,"sum","cf")
	= l_u_decomp(r,"finc","cf") + l_u_decomp(r,"trns","cf") + l_u_decomp(r,"oth","cf");
    l_u_decomp("sum","finc","cf") = sum(r, l_u_decomp(r,"finc","cf"));
    l_u_decomp("sum","trns","cf") = sum(r, l_u_decomp(r,"trns","cf"));
    l_u_decomp("sum","oth","cf") = sum(r, l_u_decomp(r,"oth","cf"));
    l_u_decomp("sum","sum","cf") = sum(r, l_u_decomp(r,"sum","cf"));
    display l_u_decomp;

*	Share of individual component in utility:
    l_u_sh(r,"finc","cf")
	= l_u_decomp(r,"finc","cf") / l_u_decomp(r,"sum","cf");
    l_u_sh(r,"trns","cf")
	= l_u_decomp(r,"trns","cf") / l_u_decomp(r,"sum","cf");
    l_u_sh(r,"oth","cf")
	= l_u_decomp(r,"oth","cf") / l_u_decomp(r,"sum","cf");
    l_u_sh("sum","finc","cf")
	= l_u_decomp("sum","finc","cf") / l_u_decomp("sum","sum","cf");
    l_u_sh("sum","trns","cf")
	= l_u_decomp("sum","trns","cf") / l_u_decomp("sum","sum","cf");
    l_u_sh("sum","oth","cf")
	= l_u_decomp("sum","oth","cf") / l_u_decomp("sum","sum","cf");

*	BOP:
    l_bop(r,"cf") =
	sum(i$ex0(i,r), exx_.l(i,r))
	- sum(i$im0(i,r), im0(i,r) * im_.l(i,r));
    l_bop("sum","cf") = sum(r, l_bop(r,"cf"));

*	GDP (expenditure side):
    l_vgdp(r,"cf") =
	p_c_.l(r) * c0(r) * c_.l(r)
	+ p_gov_.l(r) * gexp0(r) * gov_.l(r)
	+ p_inv_.l(r) * inv0(r) * inv_.l(r)
	+ sum(i, p_fx_.l * exx_.l(i,r))
 	- sum(i, pm0(i,r) * p_m_.l(i,r) * im0(i,r) * im_.l(i,r))
	+ sum((i,s)$r_s(r,s), p_d_.l(i,r) * a_d_.l(i,r,s) * ad_.l(i,s))
	- sum((i,s)$r_s(r,s), p_d_.l(i,s) * a_d_.l(i,s,r) * ad_.l(i,r))
	;
    l_vgdp("sum","cf") = sum(r, l_vgdp(r,"cf"));

*	Real GDP:
    l_qgdp(r,"cf") =
	c0(r) * c_.l(r)
	+ gexp0(r) * gov_.l(r)
	+ inv0(r) * inv_.l(r)
	+ sum(i, exx_.l(i,r))
 	- sum(i, im0(i,r) * im_.l(i,r))
	+ sum((i,s)$r_s(r,s), a_d_.l(i,r,s) * ad_.l(i,s))
	- sum((i,s)$r_s(r,s), a_d_.l(i,s,r) * ad_.l(i,r))
	;
    l_qgdp("sum","cf") = sum(r, l_qgdp(r,"cf"));

*	Price index of GDP (derived implicitly):
    l_pgdp(r,"cf") = l_vgdp(r,"cf") / l_qgdp(r,"cf");

*	Decomposition of GDP change:
    l_qgdp_decomp_ele(r,"con","cf") = c0(r) * c_.l(r);
    l_qgdp_decomp_ele(r,"gov","cf") = gexp0(r) * gov_.l(r);
    l_qgdp_decomp_ele(r,"inv","cf") = inv0(r) * inv_.l(r);
    l_qgdp_decomp_ele(r,"exp","cf") = sum(i, exx_.l(i,r));
    l_qgdp_decomp_ele(r,"imp","cf") = - sum(i, im0(i,r) * im_.l(i,r));
    l_qgdp_decomp_ele(r,"out","cf")
	= sum((i,s)$r_s(r,s), a_d_.l(i,r,s) * ad_.l(i,s));
    l_qgdp_decomp_ele(r,"in","cf")
	= - sum((i,s)$r_s(r,s), a_d_.l(i,s,r) * ad_.l(i,r));
    l_qgdp_decomp_ele(r,"sum","cf")
	= sum(ele_gdp, l_qgdp_decomp_ele(r,ele_gdp,"cf"));
    l_qgdp_decomp_ele("sum",ele_gdp,"cf")  = sum(r, l_qgdp_decomp_ele(r,ele_gdp,"cf"));
    l_qgdp_decomp_ele("sum","sum","cf")  = sum((r,ele_gdp), l_qgdp_decomp_ele(r,ele_gdp,"cf"));

);

* --------------------
* Local Variables:
* mode: gams
* fill-column: 80
* End:
