$ontext
Time-stamp: 	<2008-06-03 17:44:57 Shiro Takeda>
$offtext
set
    scn		Secenario			/ bau, cf /
    ele_fd	Elements of final demand	/ c, inv, ex, im, sum /
    ele_gdp	Elements of GDP			/ con, gov, inv, exp, imp, out, in /
    ele_u	Elements of utility		/ finc, trns, oth /
;
parameter    fl_bau	Set to non-zero if the current scenario is bau	/ 1 /;

*	Parameters for reporting outputs:
parameter
    chk_walras		"Parameter for checking Walras' law"
;
*	Parameters for reporting level.
parameter
    l_c			Consumption
    l_u			Utility
    l_save		Saving
    l_gov		Government expenditure
    l_exp_r		Export
    l_imp_r		Import
    l_exp_g		Export
    l_imp_g		Import
    l_fincome		Factor income
    l_u_sh		Share of individual component in utility
    l_u_decomp		Decomposition of utility
    l_y			Output
    l_pl		Price of labor
    l_pk		Price of capital
    l_pland		Price of land

    l_ev		EV (10bil yen)
    l_ev_decomp		Decomposition of EV (10bil yen)
    l_evpc		Per capita EV (1000yen)
    l_evpc_decomp	Decomposition of per capita EV (1000yen)

    l_vgdp_va		"Nominal GDP (value added, 10bil yen)"
    l_vgdp		"Nominal GDP (10bil yen)"
    l_pgdp		Price index of GDP
    l_qgdp		GDP (10bil yen)
    l_qgdp_decomp_ele   Decomposition of GDP

    l_sh_ex
    l_sh_im
    l_p_ex		Export price index
    l_p_im		Import price index
    l_tot		External TOT
    l_sh_ex_alt
    l_sh_im_alt
    l_p_ex_alt		Export price index
    l_p_im_alt		Import price index
    l_tot_alt		Level of TOT

    l_trans		"Level of transfer (10bil)"
    l_bop		"BOP (EX - IM)"
;

*	Change in variables:
parameter
    d_y			"Change in output (10bil)"
    d_qgdp		"Change in GDP (10bil)"
    d_qgdp_decomp	"Decomposition of change in GDP (10bil)"
    d_qgdppc_decomp	"Decomposition of change in per capita GDP (1000yen)"
    d_qgdppc		"Change in per capita GDP (1000yen)"
;
parameter
    pc_c		% change in consumption
    pc_u		% change in utility
    pc_u_decomp		Decomposition of welfare change (%)
    pc_save		% change in saving
    pc_gov		% change in government expenditure
    pc_y		% change in output

    pc_vgdp		% change in Nominal GDP
    pc_pgdp		% change in Price index of GDP
    pc_qgdp		% change in GDP
    pc_qgdp_decomp	Decomposition of GDP change (%)

    pc_pl		% change in price of labor
    pc_pk		% change in price of capital
    pc_pland		% change in price of land
    pc_tot		% change in external TOT
    pc_tot_alt		% change in TOT
;
parameter
    report		Summary of results
;

* --------------------
* Local Variables:
* mode: gams
* fill-column: 80
* End:
