
*	----------------------------------------------------------------------
*	Parameters and sets for adjusting tariff data:
display "com: Parameters and sets for adjusting tariff data:";

parameter
    target_rate		Target average tariff rate
;

target_rate("agr") = 0.226;
target_rate("foo") = 0.314;
target_rate("tex") = 0.071;
target_rate("wap") = 0.109;
display target_rate;

*	----------------------------------------------------------------------
*	Income tax data:
display "com: Income tax data:";

parameter
    taxl0(r)	  	labor income tax rate
    taxk0(r)	  	Capital income tax rate

    trev_l0		Tax revenue from L
    trev_k0		Tax revenue from K
    trev_t0		Total tax revenue

    tfac0
;
tfac0("l") = sum((j,s,r), labs0(j,s,r));
tfac0("k") = sum((j,s,r), caps0(j,s,r));
display tfac0;

*	Initialize income tax rates:
taxl0(r) = 0;
taxk0(r) = 0;
option taxl0:6, taxk0:6;

*	Labor tax revenue:
trev_l0 = 27609.1;
*	Total tax revenue:
trev_t0 = 44207.2;
*	Capital tax revenue:
trev_k0 = trev_t0 - trev_l0;
display trev_t0, trev_l0, trev_k0;

taxl0(r) = trev_l0 / tfac0("l");
taxk0(r) = trev_k0 / tfac0("k");

display taxl0, taxk0;

* --------------------
* local variables:
* mode: gams
* fill-column: 80
* end:
